/*#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

typedef struct{
	int u;
	int v;
	float l;
	int tip;
	float putarina;
	float w;
}veza;

void promeniPripadnost(int u, int v, int *pripadnost, int n)
{
	int i;
	int pom = pripadnost[v];
	
	for(i=0; i<n; i++)
	{
		if(pripadnost[i] == pom)
			pripadnost[i] = pripadnost[u];
	}
}


int main()
{
	float duzinaPuta, cenaPutarine, prosecnaPotrosnja, cenaPutovanja, kilometraza, cenaGoriva;
	float potrosnjaAutoput, potrosnjaRegionalni;
	int n,m;
	int *uvrsteneVeze;
	veza *veze;
	int *pripadnost;
	int i,j;
	int polaziste, odrediste;
	
	scanf("%f%f%f",&cenaGoriva,&potrosnjaAutoput,&potrosnjaRegionalni);
	potrosnjaAutoput /= 100;
	potrosnjaRegionalni /= 100;
	scanf("%d%d",&n,&m);
	float potrosnja;
	
	pripadnost = (int*)malloc(n*sizeof(int));
	uvrsteneVeze = (int*)malloc(m*sizeof(int));
	veze = (veza*)malloc(m*sizeof(veza));
	
	for(i=0; i<n; i++)
		pripadnost[i] = i;
	
	for(i=0; i<m; i++)
		uvrsteneVeze[i] = FALSE;
	
	for(i=0; i<m; i++)
	{
		scanf("%d%d%f%d",&veze[i].u,&veze[i].v,&veze[i].l,&veze[i].tip);
		if(veze[i].tip == 1)
		{
			scanf("%f",&veze[i].putarina);
			potrosnja = potrosnjaAutoput;
		}
		else
		{
			veze[i].putarina=0;
			potrosnja = potrosnjaRegionalni;
		}
		
		veze[i].w = cenaGoriva * potrosnja * veze[i].l;
	}	
	
	scanf("%d%d",&polaziste,&odrediste);
		
	for(i=0; i<m-1; i++)
		for(j=i+1; j<m; j++)
		{
			if(veze[i].w > veze[j].w)
			{
				veza pom = veze[i];
				veze[i] = veze[j];
				veze[j] = pom;
			}
		}
		
	int trenutna  = 0;
	float suma = 0;
	int brUvrstenih = 0;
	float ukupnaKilometraza=0;
	
	while(brUvrstenih < n-1)
	{
		if(pripadnost[veze[trenutna].u] !=  pripadnost[veze[trenutna].v])
		{
			suma += veze[trenutna].w;
			ukupnaKilometraza += veze[trenutna].l;
			brUvrstenih++;
			uvrsteneVeze[trenutna] = TRUE;
			
		}
		trenutna++;
	}
	
	veza *noveVeze;
	noveVeze = (veza*)malloc(m*sizeof(veza));
	
	int brNeuvrstenih = 0;
	for(i=0; i<m; i++)
		if(uvrsteneVeze[i] == FALSE)
			brNeuvrstenih++;
			
	int *pripadnostNove;
	pripadnostNove = (int*)malloc(brNeuvrstenih*sizeof(int));
		
	int br=0;
	for(i=0; i<m; i++)
	{
		if(uvrsteneVeze[i] == FALSE)
			{
				noveVeze[br++] = veze[i];
			}
	}
	
	for(i=0; i<brNeuvrstenih; i++)
		pripadnostNove[i] = i;
	
	int *noveUvrsteneVeze;
	noveUvrsteneVeze = (int*)malloc(br*sizeof(int));
	
	for(i=0; i<br; i++)
		noveUvrsteneVeze[i] = FALSE;
	
	for(i=0; i<br-1; i++)
		for(j=i+1; j<br; j++)
		{
			if(noveVeze[i].w > noveVeze[j].w)
			{
				veza pom = noveVeze[i];
				noveVeze[i] = noveVeze[j];
				noveVeze[j] = pom;
			}
		}
		
		int ind = 1;
		trenutna = 0;
		int brNovihUvrstenih = 0;
		
		
		while(brNovihUvrstenih < n-1 && trenutna < m)
		{
			if(pripadnost[noveVeze[trenutna].u] !=  pripadnost[noveVeze[trenutna].v])
			{
			suma += noveVeze[trenutna].w;
			ukupnaKilometraza += noveVeze[trenutna].l;
			brNovihUvrstenih++;
			noveUvrsteneVeze[trenutna] = TRUE;
			}
			trenutna++;
		}
		
		if(brNovihUvrstenih < n-1)
			ind = 0;
		
		
	
	
}
*/

#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0
#define NILL -1
#define INF -1


float jeManji(float a, float b)
{
	if(a==INF)
		return FALSE;
	if(b==INF)
		return TRUE;
	return a<b;
}

int nadjiMinimum(float *d, int *obidjen, int n, int *iskorisceni)
{
	int min=INF;
	int minCvor=INF;
	int i;
	
	for(i=0; i<n; i++)
	{
		if(jeManji(d[i], min) && iskorisceni[i] == FALSE)
		{
			min=d[i];
			minCvor = i;
		}
	}
	return minCvor;
}

void relax(int u, int v, int *pret, int **graf, float *d)
{
	if(jeManji(d[u] + graf[u][v], d[v]))
	{
		d[v] = d[u] + graf[u][v];
		pret[v] = u;
	}
}

void dijkstra(int **graf,float *d,int *obidjen,int *pret,int n,int *iskorisceni)
{
	int u,v;
	int i;
	for(i=0; i<n; i++)
	{
		u = nadjiMinimum(d,obidjen,n,iskorisceni);
		obidjen[u] = TRUE;
		for(v=0; v<n; v++)
		{
			if(graf[u][v]!=INF && obidjen[v] == FALSE && iskorisceni[i]==FALSE)
				relax(u,v,pret,graf,d);
		}
	}
}

void stampajPut(int polaziste, int odrediste, int *pret)
{
	if(polaziste == odrediste)
		printf("%d ",polaziste);
	else if(pret[odrediste] == NILL)
		printf("Nema puta");
	else
		{
			stampajPut(polaziste,pret[odrediste],pret);
			printf("%d ", odrediste);
		}
}

void obelezi(int *iskorisceni, int pol, int odr, int *pret)
{
	if(odr == pol)
		return;
	else if(pret[odr] == NILL)
		printf("ne\n");
	else
		{
			iskorisceni[odr] = TRUE;
			obelezi(iskorisceni,pol,pret[odr],pret);
		}
}

int main()
{
	float cenaGoriva;
	float potrosnjaAutoput, potrosnjaRegionalni;
	int n,m;
	int *obidjenP, *pretP, *obidjenD, *pretD;
	float *dP, *dD;
	int **graf;
	int i,j;
	int *iskorisceni;
	
	scanf("%f%f%f",&cenaGoriva,&potrosnjaAutoput,&potrosnjaRegionalni);
	potrosnjaAutoput /= 100;
	potrosnjaRegionalni /= 100;
	
	scanf("%d%d",&n,&m);
	
	graf = (int**)malloc(n*sizeof(int*));
	for(i=0; i<n; i++)
			graf[i] = (int*)malloc(n*sizeof(int));
			
	dP = (float*)malloc(n*sizeof(float));
	obidjenP = (int*)malloc(n*sizeof(int));
	pretP = (int*)malloc(n*sizeof(int));
	
	
	dD = (float*)malloc(n*sizeof(float));
	obidjenD = (int*)malloc(n*sizeof(int));
	pretD = (int*)malloc(n*sizeof(int));
	
	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			graf[i][j] = INF;
			
	for(i=0; i<n; i++)
	{
		pretP[i]=NILL;
		obidjenP[i]=FALSE;
		dP[i]=INF;
		
		pretD[i]=NILL;
		obidjenD[i]=FALSE;
		dD[i]=INF;
	}
	
	float putarina;
	float potrosnja;
	float w;
	
	int tip,u,v;
	float l;
	for(i=0; i<m; i++)
	{
		scanf("%d%d%f%d",&u,&v,&l,&tip);
		if(tip == 1)
			{
				scanf("%f",&putarina);
				potrosnja = potrosnjaAutoput;
			}
			else
			{
				putarina = 0;
				potrosnja = potrosnjaRegionalni;
			}
		
		w = cenaGoriva*potrosnja*l;
		
		graf[u][v] = graf[v][u] = w;	
		
	}
	
	int polaziste,odrediste;
	
	scanf("%d%d",&polaziste,&odrediste);
	
	int pol1,odr1,pol2,odr2;
	
	pol1 = polaziste;
	odr1=odrediste;
	
	pol2=odrediste;
	odr2=polaziste;
	
	dP[pol1] = 0;
	dD[pol2] = 0;
	
	iskorisceni = (int*)malloc(n*sizeof(int));
	for(i=0; i<n; i++)
		iskorisceni[i] = FALSE;
	
	dijkstra(graf,dP,obidjenP,pretP,n,iskorisceni);
	
	/*for(i=0; i<n; i++)
	{
		if(obidjenP[i] == TRUE)
			obidjenD[i] = TRUE;
	}
	* */
	

		
	obelezi(iskorisceni,pol1,odr1,pretP);
	
	dijkstra(graf, dD, obidjenD, pretD,n,iskorisceni);
	
	float suma;
	suma = dP[odr1] + dD[odr2];
	
	printf("%.4f",suma);
    stampajPut(pol1,odr1,pretP);
	stampajPut(pol2,odr2,pretD);
	
		
	
	
	return 0;
}

