#include<stdio.h>
#include<stdlib.h>

#define skupb 1
#define skupn 0

int n,m,*bn;
double **a,*b,*c,*x,v,p;

void UnesiPodatke()
{
    int i,j;
    double d1Sljiva,d1Kajsija,d1Visnja,d1Secer;
    double d2Sljiva,d2Kajsija,d2Secer;
    double d3Sljiva,d3Visnja,d3Secer;
    double d4Kajsija,d4Visnja,d4Secer;
    double budzet,secer,sljiva,kajsija,visnja;
    double *trosak;
    v=0;
    n=4;
    //n=8;
    m=5;
    //m=6;

    a=(double **)malloc((n+m)*sizeof(double *));
    for(i=0;i<n+m;i++)
        a[i]=(double *)malloc((n+m)*sizeof(double));
    
    x=(double *)malloc((n+m)*sizeof(double));
    c=(double *)malloc((n+m)*sizeof(double));
    b=(double *)malloc((n+m)*sizeof(double));
    trosak=(double *)malloc(n*sizeof(double));
    bn=(int *)malloc((n+m)*sizeof(int));

    scanf("%lf %lf %lf %lf",&d1Sljiva,&d1Kajsija,&d1Visnja,&d1Secer);
    scanf("%lf %lf %lf",&d2Sljiva,&d2Kajsija,&d2Secer);
    scanf("%lf %lf %lf",&d3Sljiva,&d3Visnja,&d3Secer);
    scanf("%lf %lf %lf",&d4Kajsija,&d4Visnja,&d4Secer);

    scanf("%lf",&secer);
    scanf("%lf\n",&sljiva);
    scanf("%lf\n",&kajsija);
    scanf("%lf\n",&visnja);

    for(i=0;i<n;i++)
    {
        scanf("%lf\n",&c[i]);
        b[i]=0;
        bn[i]=skupn;
    }

    scanf("%lf\n",&budzet);
    for(i=0;i<n;i++)
    {
        scanf("%lf\n",&trosak[i]);
        c[i]-=trosak[i];
    }

    for(i=n;i<n+m;i++)
    {
        //scanf("%lf",&b[i]);
        bn[i]=skupb;
        c[i]=0;
    }
/*
    for(i=0;i<n;i++)
        printf("%lf ",c[i]);
    printf("\n");
*/


    b[n]=secer;
    b[n+1]=sljiva;
    b[n+2]=kajsija;
    b[n+3]=visnja;
    b[n+4]=budzet;
/*
        for(i=n;i<n+m;i++)
        printf("%lf ",b[i]);
    printf("\n");
*/

    a[n][0]=d1Secer;
    a[n][1]=d2Secer;
    a[n][2]=d3Secer;
    a[n][3]=d4Secer;

    a[n+1][0]=d1Sljiva;
    a[n+1][1]=d2Sljiva;
    a[n+1][2]=d3Sljiva;
    a[n+1][3]=0;

    a[n+2][0]=d1Kajsija;
    a[n+2][1]=d2Kajsija;
    a[n+2][2]=0;
    a[n+2][3]=0;

    a[n+3][0]=d1Visnja;
    a[n+3][1]=0;
    a[n+3][2]=d3Visnja;
    a[n+3][3]=d4Visnja;

    a[n+4][0]=trosak[0];
    a[n+4][1]=trosak[1];
    a[n+4][2]=trosak[2];
    a[n+4][3]=trosak[3];
/*
    a[n+5][0]=-trosak[0];
    a[n+5][1]=-trosak[1];
    a[n+5][2]=-trosak[2];
    a[n+5][3]=-trosak[3];
*/

}


int NadjiUlaz()
{
    int i,e=-1;

    for(i=0;i<n+m;i++)
    {
        if(bn[i]==skupn && c[i]>0)
        {
            e=i;
            break;
        }
    }

    return e;
}

int NadjiIzlaz(int e)
{
    int i,l=-1;
    double min;

    for(i=0;i<n+m;i++)
    {
        if(bn[i]==skupb && a[i][e]>0)
        {
            if(l==-1)
            {
                min=b[i]/a[i][e];
                l=i;
            }
            else
            {
                if(b[i]/a[i][e] < min)
                {
                    min=b[i]/a[i][e];
                    l=i;
                }
            }
        }
    }

    return l;
}

void Pivot(int e,int l)
{
    int i,j;
    b[e]=b[l]/a[l][e];

    for(i=0;i<n+m;i++)
    {
        if(bn[i]==skupn && i!=e)
        {
            a[e][i]=a[l][i]/a[l][e];
        }
    }
    a[e][l]=1/a[l][e];

    for(i=0;i<n+m;i++)
    {
        if(bn[i]==skupb && i!=l)
        {
            b[i]-=a[i][e]*b[e];
            for(j=0;j<n+m;j++)
            {
                if(bn[j]==skupn && j!=e)
                {
                    a[i][j]-=a[i][e]*a[e][j];
                }
            }
            a[i][l]=-a[i][e]*a[e][l];
        }
    }

    v+=c[e]*b[e];

    for(i=0;i<n+m;i++)
    {
        if(bn[i]==skupn && i!=e)
        {
            c[i]-=c[e]*a[e][i];
        }
    }
    c[l]=-c[e]*a[e][l];
    
    bn[e]=skupb;
    bn[l]=skupn;

}


int main()
{
    int i,e,l;

    UnesiPodatke();

    while( (e=NadjiUlaz())!=-1 )
    {
        l=NadjiIzlaz(e);

        if(l==-1)
        {
            printf("Neograniceno\n");
            break;
        }
        else
        {
            Pivot(e,l);
        }

    }

    if(e==-1)
    {
        for(i=0;i<n;i++)
        {
            if(bn[i]==skupb)
                x[i]=b[i];
            else
                x[i]=0;
        }

        //p=b[4];
        //printf("preteklo %lf\n",p);
        //v-=p;

       // for(i=n;i<n+m;i++)
       //    printf("%lf ",b[i]);
        

        printf("%.2lf\n",v);
        for(i=0;i<n;i++)
        printf("%.2lf ",x[i]);
        printf("\n");
    }




    return 0;
}