#include <stdio.h>
#include <stdlib.h>

#define skupB 1
#define skupN 0

double **a, *b, *c, *x;
double v;
int *bn;
int m, n;

void unesiPodatke(){
	int i;
	n = 4;
	m = 5;
	
	int q = m+n;
	
	a = (double **)malloc(q*sizeof(double *));
	
	for(i=0;i<q;i++)
		a[i] = (double *)malloc(q*sizeof(double ));
	
	b = (double *)malloc(q*sizeof(double ));
	c = (double *)malloc(q*sizeof(double ));
	x = (double *)malloc(q*sizeof(double ));
	bn = (int *)malloc(q*sizeof(int ));
	
	
	double sljiva1, sljiva2, sljiva3;
	double kajsija1, kajsija2, kajsija3;
	double visnja1, visnja2, visnja3;
	double secer1, secer2, secer3, secer4;
	double secer, sljiva, kajsija, visnja;
	double troskovi1, troskovi2, troskovi3, troskovi4;
	double budzet;
	
	scanf("%lf%lf%lf%lf", &sljiva1, &kajsija1, &visnja1, &secer1);
	scanf("%lf%lf%lf", &sljiva2, &kajsija2, &secer2);
	scanf("%lf%lf%lf", &sljiva3, &visnja2, &secer3);
	scanf("%lf%lf%lf",  &kajsija3, &visnja3, &secer4);
	
	scanf("%lf%lf%lf%lf", &secer, &sljiva, &kajsija, &visnja);
	
	
	for(i=0;i<n;i++){
		scanf("%lf", &c[i]);
		bn[i] = skupN;
		b[i] = 0;
	}
	
	
	for(i=n;i<m;i++){
		//scanf("%lf", &b[i]);
		bn[i] = skupB;
		c[i] = 0;
	}
	scanf("%lf", &budzet);
	scanf("%lf%lf%lf%lf", &troskovi1, &troskovi2, &troskovi3, &troskovi4);
	
	c[0] -= troskovi1;
	c[1] -= troskovi2;
	c[2] -= troskovi3;
	c[3] -= troskovi4;
	
	
	
	b[n] = budzet;
	b[n+1] = sljiva;
	b[n+2] = kajsija;
	b[n+3] = visnja;
	b[n+4] = secer;
	
	
	
	a[n][0] = troskovi1;
	a[n][1] = troskovi2;
	a[n][2] = troskovi3;
	a[n][3] = troskovi4;
	
	
	a[n+1][0] = sljiva1;
	a[n+1][1] = sljiva2;
	a[n+1][2] = sljiva3;
	a[n+1][3] = 0;
	
	a[n+2][0] = kajsija1;
	a[n+2][1] = kajsija2;
	a[n+2][2] = 0;
	a[n+2][3] = kajsija3;
	
	a[n+3][0] = visnja1;
	a[n+3][1] = 0;
	a[n+3][2] = visnja2;
	a[n+3][3] = visnja3;
	
	a[n+4][0] = secer1;
	a[n+4][1] = secer2;
	a[n+4][2] = secer3;
	a[n+4][3] = secer4;
	
	
	
	v=0;
}


int nadjiUlaz(){
	int i, e=-1;
	for(i=0;i<m+n;i++){
		if(bn[i]==skupN && c[i]>0){
			e = i;
			break;
		}
	}
	return e;
}
int nadjiIzlaz(int e){
	int i, l = -1;
	int min;
	
	for(i=0;i<n+m;i++){
		if(bn[i] == skupN && a[i][e] > 0){
			if(l == -1){
				l = i;
				min = b[i] / a[i][e];
			}
			else{
				if(min > b[i] / a[i][e]){
					l = i;
					min = b[i] / a[i][e];
				}
				
			}
		}
	}	
	return l;
}
void pivot(int e, int l){
	int i, j;
	b[e] = b[l] * a[l][e];
	for(j=0;j<n+m;j++){
		if(bn[j]==skupN && j!=e){
			a[e][j] = a[l][j] / a[l][e];
		}
	}
	a[e][l] = 1/a[l][e];
	
	for(i=0;i<n+m;i++){
		if(bn[i] == skupB && i!=l){
			b[i] = b[i] - a[i][e]*b[e];
			for(j=0;j<n+m;j++){
				if(bn[j]==skupN && j!=e){
					a[i][j] = a[i][j] - a[i][e]/ a[e][j];
				}
				
			}
			a[i][l] = -a[i][e]*a[e][l];
		}
	}
	
	
	v = v+c[e]*b[e];
	
	for(j=0;j<n+m;j++){
		if(bn[j]==skupN && j!=e){
			c[j] = c[j] - c[e]* a[e][j];
		}
	}		
	c[l] = -c[e]*a[e][l];
	
	bn[e] = skupB;
	bn[l] = skupN;
}


int main(){
	int e, l;
	int i;
	unesiPodatke();
	
	while((e=nadjiUlaz())!=-1){
		l = nadjiIzlaz(e);
		
		if(l==-1)
			break;
		else
			pivot(e, l);
	}
	
	if(e == -1){
		
		for(i=0;i<n;i++){
			if(bn[i]==skupB){
				x[i] = b[i];
			}
			else
				x[i] = 0;
		}
		
		printf("%.2lf\n", v);
		for(i=0;i<n;i++){
			printf("%3.2lf\t", x[i]);
		}
		
	}
	printf("\n");
}
