#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct Program
{
    int id;
    int vreme;      //trajanje svakog od proracuna na jednoporcesorkosm h. (sekuna)
    int vaznost;
    double latencija;       //sekunda
} Program;

//viseprocesorski - vreme izvrsavanja + vreme komunikacije
//u jednom trenutku samo jedan proracun i on se paralelizuje na SVE procesore
//sto veca vaznost

int main()
{
    Program *programi;
    int *brojProcesora;
    int i, j;
    int n, p;
    int dostupnoVreme;
    scanf("%d", &n);

    brojProcesora = (int *)malloc((n+1) * sizeof(int));
    for(i = 1; i <= n; i++)
        scanf("%d", &brojProcesora[i]);     //broj procesora na odredjenoj arhitekturi

    scanf("%d", &dostupnoVreme);    
    //minuti
    //dostupno vreme hardvera za jedan procesor
    //ako je za jedan procesor onda je za n = dostupnoVreme * n
    dostupnoVreme *= 60;

    scanf("%d", &p);
    int id, vreme, vaznost;
    double latencija;
    programi = (Program *)malloc((p+1) * sizeof(Program));
    for(i = 1; i <= p; i++)
    {
        scanf("%d", &id);
        scanf("%d", &vreme);  
        scanf("%d", &vaznost);
        scanf("%lf", &latencija);

        programi[i].id = id;
        programi[i].vreme = vreme;
        programi[i].vaznost = vaznost;
        programi[i].latencija = latencija;
    }

    int **opt;
    opt = (int **)malloc((n + 1) * sizeof(int *));
    for(i = 0; i <= n; i++)
        opt[i] = (int *)malloc((p + 1) * sizeof(int));
    
    for(i = 0; i <= n; i++)  
        opt[i][0] = 0;
    for(i = 1; i <= p; i++)
        opt[0][i] = 0;

    int d, izv;
    int izvPret;
    for(i = 1; i <= n; i++)
    {
        d = ceil(dostupnoVreme / brojProcesora[i]);
        for(j = 1; j <= p; j++)
        {
            izv = ceil(programi[j].vreme / brojProcesora[i] + programi[j].latencija * brojProcesora[i]);
                
            // if(opt[i][j-1] == 0)
            // {
                if(izv <= d)
                    opt[i][j] = programi[j].vaznost;
                else
                    opt[i][j] = 0;
            // }
            // else
            // {
                //printf("else j: %d\n", j);
                // izvPret = ceil(programi[j-1].vreme / brojProcesora[i] + programi[j-1].latencija * brojProcesora[i]);
                // if((izv + izvPret) <= d)
                // {
                //     opt[i][j] = opt[i][j-1] + programi[j].vaznost;
                // }
                // else
                // {
                //     opt[i][j] = opt[i][j-1];
                // }

                // if(izv <= d)
                //     opt[i][j] = programi[j].vaznost;

                if(j > 1)
                {

                    int k = j-1;
                    while(k >= 0)
                    {
                        izvPret = ceil(programi[k].vreme / brojProcesora[i] + programi[k].latencija * brojProcesora[i]);
                        if((izv + izvPret) <= d && (opt[i][k] + programi[j].vaznost) > opt[i][j])
                        {
                            opt[i][j] = opt[i][k] + programi[j].vaznost;
                        }
                        else
                        {
                            opt[i][j] = opt[i][k];
                        }

                        k--;
                    }
                }
                else
                {
                    izvPret = ceil(programi[j-1].vreme / brojProcesora[i] + programi[j-1].latencija * brojProcesora[i]);
                    if((izv + izvPret) <= d && (opt[i][j-1] + programi[j].vaznost) > opt[i][j])
                    {
                        opt[i][j] = opt[i][j-1] + programi[j].vaznost;
                    }
                    else
                    {
                        opt[i][j] = opt[i][j-1];
                    }
                }
            //}
        }
    }

    int max = 0;
    int index;
    for(i = i = 1; i < n; i++)
    {
        if(max <= opt[i][p])
        {
            max = opt[i][p];
            index = i;
        }
    }

    printf("%d\n", brojProcesora[index]);
    printf("%d\n", max);


    //rekonstrukcija

    j = p;
    while(j!=0)
    {
        if((opt[index][j] - programi[j].vaznost) == opt[index][j-1])
        {
            printf("%d ", programi[j].id);
        }
        j--;
    }

    printf("\n");

    return 0;
}