//neusmeren

#include <stdio.h>
#include <stdlib.h>

#define FALSE 0
#define TRUE 1
#define INF -1
#define NILL -1

typedef struct Put
{
    int u, v;
    double l;
    int tip;
    double putarina;
    double cena;
} Put;

int jeManji(int x, int y)
{
    if(x == -1)
        return FALSE;

    if(y == -1)
        return TRUE;

    return x<y;
}

int nadjiNajboljeg(int **graf, int n, int *pret, int *d)
{
    int min = INF;
    int minCvore = NILL;

    for(i = 0; i < n; i++)
    {

    }

}

void dijkstra(int **graf, int *pret, int *d, int *obidjen, int n)
{
    int u, i;

    for(i = 0; i < n; i++)
    {
        u = nadjiNajboljeg();
        if(u == -1)
        {
            printf("-1\n");
            return;
        }
    }
}

void relax(int **graf, int *pret, int *d, int u, int v, int n)
{

}

int main()
{
    int polaziste, odrediste;
    Put *putevi;
    int i, j;
    int n, m;   //n - broj cvorova; m - broj veza
    double potrosnjaAutoput, potrosnjaRegionalniPut;
    double cenaGoriva, cenaPutovanja = 0;
    int *pret, *d, *obidjen;
    int **graf;
    
    scanf("%lf", &cenaGoriva);
    scanf("%lf%lf", &potrosnjaAutoput, &potrosnjaRegionalniPut);
    scanf("%d%d", &n, &m);

    obidjen = (int *)malloc(n * sizeof(int));
    pret = (int *)malloc(n * sizeof(int));
    d = (int *)malloc(n * sizeof(int));
    graf = (int **)malloc(n * sizeof(int *));
    for(i = 0; i < n; i++)
        graf[i] = (int *)malloc(n * sizeof(int));

    for(i = 0; i < n; i++)
        for(j = 0; j < n; j++)
            graf[i][j] = FALSE;

    putevi = (Put *)malloc(m * sizeof(Put));
    for(i = 0; i < m; i++)
    {
        scanf("%d", &putevi[i].u);
        scanf("%d", &putevi[i].v);
        scanf("%lf", &putevi[i].l);
        scanf("%d", &putevi[i].tip);
        if(putevi[i].tip == 1)
            scanf("%lf", &putevi[i].putarina);
        
        graf[putevi[i].u][putevi[i].v] = graf[putevi[i].v][putevi[i].u] = TRUE;
        if(putevi[i].putarina)
            putevi[i].cena = putevi[i].putarina + (putevi[i].l/100)*potrosnjaAutoput*cenaGoriva;
        else
            putevi[i].cena = (putevi[i].l/100)*potrosnjaRegionalniPut*cenaGoriva;

        obidjen[i] = FALSE;
    }

    for(i = 0; i < n; i++)
    {
        d[i] = INF;
        pret[i] = NILL;
    }

    scanf("%d%d", &polaziste, &odrediste);

    dijkstra(graf, pret, d, obidjen, n);



    return 0;
} 