#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

int m, n;
double **a, *b, *c, *x;
int *BN;
double v;


void unesiPodatke()
{
	int i;
	double secer, sljiva, kajsija, visnja, budzet;
	m=5;
	n=4;
	
	a=(double**)malloc((n+m)*sizeof(double*));
	for(i=0; i<(n+m); i++)
		a[i]=(double*)calloc((n+m),sizeof(double));
		
	b=(double*)malloc((n+m)*sizeof(double));
	c=(double*)malloc((n+m)*sizeof(double));
	x=(double*)malloc((n+m)*sizeof(double));
	BN=(int*)malloc((n+m)*sizeof(int));

		
	scanf("%lf%lf%lf%lf", &a[n+1][0], &a[n+2][0], &a[n+3][0], &a[n+4][0]);
	scanf("%lf%lf%lf", &a[n+1][1], &a[n+2][1], &a[n+4][1]);
	scanf("%lf%lf%lf", &a[n+1][2], &a[n+3][2], &a[n+4][2]);
	scanf("%lf%lf%lf", &a[n+2][3], &a[n+3][3], &a[n+4][3]);
	
	scanf("%lf%lf%lf%lf", &secer, &sljiva, &kajsija, &visnja);
	
	for(i=0; i<n; i++)
	{
		scanf("%lf", &c[i]);
		b[i]=0;
		BN[i]=SKUP_N;
	}
	scanf("%lf", &budzet);
	
	for(i=n; i<(n+m); i++)
	{
		c[i]=0;
		BN[i]=SKUP_B;
	}
	
	scanf("%lf%lf%lf%lf", &a[n][0], &a[n][1], &a[n][2], &a[n][3]);
	
	b[n]=budzet;
	b[n+1]=sljiva;
	b[n+2]=kajsija;
	b[n+3]=visnja;
	b[n+4]=secer;
	
	v=0.0;
}

int nadjiUlaz()
{
	int i;
	int e=-1;
	for(i=0; i<(n+m); i++)
	{
		if(BN[i]==SKUP_N && c[i]>0)
		{
			e=i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e)
{
	int l=-1;
	int i;
	double min;
	for(i=0; i<(n+m); i++)
	{
		if(BN[i]==SKUP_B && a[i][e]>0)
		{
			if(l==-1)
			{
				min=b[i]/a[i][e];
				l=i;
			}
			else
			{
				if(b[i]/a[i][e]<min)
				{
					min=b[i]/a[i][e];
					l=i;
				}
			}
		}
	}
	return l;
}

void pivot(int e, int l)
{
	int i, j;
	b[e]=b[l]/a[l][e];
	for(j=0; j<(m+n); j++)
	{
		if(BN[j]==SKUP_N && j!=e)
		{
			a[e][j]=a[l][j]/a[l][e];
		}
	}
	a[e][l]=1/a[l][e];
	for(i=0; i<(n+m); i++)
	{
		if(BN[i]==SKUP_B && i!=l)
		{
			b[i]=b[i]-a[i][e]*b[e];
			for(j=0; j<(n+m); j++)
			{
				if(BN[j]==SKUP_N && j!=e)
				{
					a[i][j]=a[i][j]-a[i][e]*a[e][j];
				}
			}
			a[i][l]=-a[i][e]*a[e][l];
		}
	}
	v=v+c[e]*b[e];
	for(j=0; j<(n+m); j++)
	{
		if(BN[j]==SKUP_N && j!=e)
		{
			c[j]=c[j]-c[e]*a[e][j];
		}
	}
	c[l]=-c[e]*a[e][l];
	BN[e]=SKUP_B;
	BN[l]=SKUP_N;
}
int main()
{
	int e, l, j;
	//v=0.0;
	unesiPodatke();
	while((e=nadjiUlaz())!=-1)
	{
		l=nadjiIzlaz(e);
		if(l==-1)
		{
			printf("Problem neogranicen\n");
			break;
		}
		else
		{
			pivot(e,l);
		}
	}
	if(e==-1)
	{
		for(j=0; j<n; j++)
		{
			if(BN[j]==SKUP_B)
			{
				x[j]=b[j];
			}
			else
			{
				x[j]=0;
			}
		}
		printf("%.2lf\n", v);
		for(j=0; j<n; j++)
		{
			printf("%.2lf ", x[j]);
		}
		printf("\n");
	}
	return 0;
}
