#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

int *pripadnost, brCvorova, brVeza, polaziste, odrediste, trenutna, brUvrstenih, *uvrsteneVeze;

double potrosnja, kilometraza;


typedef struct
{
	int grad1;
	int grad2;
	float kilometraza;
	int tip;
	int putarina;
	
}Veza;

Veza *veze;

void promeniPripadnost(int u, int v)
{
	int i;
	int pom=pripadnost[v];
	for(i=0; i<brCvorova; i++)
	{
		if(pripadnost[i]==pom)
		{
			pripadnost[i]=pripadnost[u];
		}
	}
}

int main()
{
	int i, j;
	float cenaGoriva;
	float potrosnjaA, potrosnjaR;
	
	scanf("%f", &cenaGoriva);
	scanf("%f%f", &potrosnjaA, &potrosnjaR);
	
	scanf("%d%d", &brCvorova, &brVeza);
	pripadnost=(int*)malloc((brCvorova+1)*sizeof(int));
	uvrsteneVeze=(int*)malloc((brVeza+1)*sizeof(int));
	veze=(Veza*)malloc((brVeza+1)*sizeof(Veza));
	
	for(i=0; i<brCvorova; i++)
		pripadnost[i]=i;
		
	for(i=0; i<brVeza; i++)
	{
		scanf("%d%d%f", &veze[i].grad1, &veze[i].grad2, &veze[i].kilometraza);
		scanf("%d", &veze[i].tip);
		if(veze[i].tip==1)
			scanf("%d", &veze[i].putarina);
		uvrsteneVeze[i]=FALSE;
	}
	
	scanf("%d%d", &polaziste, &odrediste);
	
	/*for(i=0; i<brVeza; i++)
	{
		if((int)veze[i].kilometraza%polaziste==0)
			veze[i].kilometraza=(veze[i].kilometraza/(float)polaziste-1)*(float)odrediste;
		else
			veze[i].kilometraza=(veze[i].kilometraza/(float)polaziste)*(float)odrediste;
	}*/
	
	kilometraza=0.0;
	potrosnja=0.0;
	trenutna=1;
	brUvrstenih=0;
	/*for(i=0; i<brVeza-1; i++)
	{
		for(j=i+1; j<brVeza; j++)
		{
			if(veze[i].kilometraza>veze[j].kilometraza)
			{
				Veza pom=veze[i];
				veze[i]=veze[j];
				veze[j]=pom;
			}
		}
	}*/
	while(brUvrstenih < brCvorova-1)
	{
		if(pripadnost[veze[trenutna].grad1] != pripadnost[veze[trenutna].grad2])
		{
			promeniPripadnost(veze[trenutna].grad1, veze[trenutna].grad2);
			kilometraza+=veze[trenutna].kilometraza;
			if(veze[trenutna].tip==1)
			{
				potrosnja+=veze[trenutna].putarina;
				potrosnja+=((veze[trenutna].kilometraza/100.0)*potrosnjaA)*cenaGoriva;
			}
			else
			{
				potrosnja+=((veze[trenutna].kilometraza/100.0)*potrosnjaR)*cenaGoriva;
			}
			brUvrstenih++;
			uvrsteneVeze[trenutna]=TRUE;
		}
		trenutna++;
	}
	
	printf("%.4lf\n", potrosnja);
	printf("%.4lf\n", kilometraza);
	/*for(i=1; i<=brVeza; i++)
	{
		if(uvrsteneVeze[i])
		{
			printf("(%d, %d) %f\n", veze[i].grad1, veze[i].grad2, veze[i].kilometraza);
		}
	}*/
}

