#include<stdio.h>
#include<stdlib.h>
#define SKUP_N 0
#define SKUP_B 1

#define INF -1
#define NILL -1
#define TRUE 1
#define FALSE 0


double **a;
double *b;
double *c;
double *x;
int *BN;
int n,m;
double v;

int minimum(int i, int j){
	if(i == INF)
		return FALSE;
	if(j == INF)
		return TRUE;
	return i<j;
}

void unesiPodatke(){
	
	int i,j;
	
	double d1_sljiva, d1_kajsija, d1_visnja, d1_secer;
	double d2_sljiva, d2_kajsija, d2_secer;
	double d3_sljiva, d3_visnja, d3_secer;
	double d4_kajsija, d4_visnja, d4_secer;
	double secer, sljiva, kajsija, visnja;
	double cena1, cena2, cena3, cena4;
	double budzet;
	double trosak1, trosak2, trosak3, trosak4;
	
	n=4;
	m=5;
	
	a = (double**)malloc((n+m)*sizeof(double*));
	for(i=0; i<(n+m); i++){
		a[i] = (double*)malloc((n+m)*sizeof(double));
	}
	b = (double*)malloc((n+m)*sizeof(double));
	c = (double*)malloc((n+m)*sizeof(double));
	x = (double*)malloc((n+m)*sizeof(double));
	BN = (int*)malloc((n+m)*sizeof(int));
	
	scanf("%lf%lf%lf%lf",&d1_sljiva, &d1_kajsija, &d1_visnja, &d1_secer);
	scanf("%lf%lf%lf",&d2_sljiva, &d2_kajsija, &d2_secer);
	scanf("%lf%lf%lf",&d3_sljiva, &d3_visnja, &d3_secer);
	scanf("%lf%lf%lf",&d4_kajsija, &d4_visnja, &d4_secer);
	
	scanf("%lf",&secer);
	scanf("%lf",&sljiva);
	scanf("%lf",&kajsija);
	scanf("%lf",&visnja);
	
	scanf("%lf",&cena1);
	scanf("%lf",&cena2);
	scanf("%lf",&cena3);
	scanf("%lf",&cena4);
	
	scanf("%lf",&budzet);
	
	scanf("%lf",&trosak1);
	scanf("%lf",&trosak2);
	scanf("%lf",&trosak3);
	scanf("%lf",&trosak4);
	
	c[0] = cena1 - trosak1;
	c[1] = cena2 - trosak2;
	c[2] = cena3 - trosak3;
	c[3] = cena4 - trosak4;
	c[4]=0;
	c[5]=0;
	c[6]=0;
	c[7]=0;
	c[8]=0;
	BN[0]=SKUP_N;
	BN[1]=SKUP_N;
	BN[2]=SKUP_N;
	BN[3]=SKUP_N;
	
	b[0]=0;
	b[1]=0;
	b[2]=0;
	b[3]=0;
	b[4] = secer;
	b[5] = sljiva;
	b[6] = kajsija;
	b[7] = visnja;
	b[8] = budzet;
	BN[4] = SKUP_B;
	BN[5] = SKUP_B;
	BN[6] = SKUP_B;
	BN[7] = SKUP_B;
	BN[8] = SKUP_B;
	
	for(i=0; i<(n+m); i++){
		for(j=0; j<(n+m); j++){
			a[i][j] = 0;
		}
	}
	
	a[n][0] = d1_secer;
	a[n][1] = d2_secer;
	a[n][2] = d3_secer;
	a[n][3] = d4_secer;
	
	a[n+1][0] = d1_sljiva;
	a[n+1][1] = d2_sljiva;
	a[n+1][2] = d3_sljiva;
	a[n+1][3] = 0;
	
	a[n+2][0] = d1_kajsija;
	a[n+2][1] = d2_kajsija;
	a[n+2][2] = 0;
	a[n+2][3] = d4_kajsija;
	
	a[n+3][0] = d1_visnja;
	a[n+3][1] = 0;
	a[n+3][2] = d3_visnja;
	a[n+3][3] = d4_visnja;
	
	a[n+4][0] = trosak1;
	a[n+4][1] = trosak2;
	a[n+4][2] = trosak3;
	a[n+4][3] = trosak4;
	
	v=0;
	
}

int nadjiUlaz(){
	int i;
	int e=-1;
	
	for(i=0; i<(n+m); i++){
		if(BN[i]==SKUP_N && c[i]>0){
			e=i;
			break;
		}
	}
	
	return e;
	
}

int nadjiIzlaz(int e){
	int i;
	int l=-1;
	int min = INF;
	
	for(i=0; i<(n+m); i++){
		if(BN[i] == SKUP_B && a[i][e]>0){
			if(l==-1){
				min = b[i] / a[i][e];
				l = i;
			}else{
				if(min < b[i] / a[i][e]){
					min = b[i] / a[i][e];
					l = i;
				}
			}
		}
	}
	
	return l;
	
}

void pivot(int e, int l){
	int i,j;
	
	b[e] = b[l] / a[l][e];
	
	for(j=0; j<(n+m); j++){
		if(BN[j] == SKUP_N && j!=e){
			a[e][j] = a[l][j] / a[l][e];
		}
	}
	
	a[e][l] = 1 / a[l][e];
	
	for(i=0; i<(n+m); i++){
		if(BN[i] == SKUP_B && i!=l){
			b[i] = b[i] - a[i][e]*b[e];
			for(j=0; j<(n+m); j++){
				a[i][j] = a[i][j] - a[i][e] * a[e][j];
			}
			a[i][l] = -a[i][e] * a[e][l];
		}
	}
	
	v = v + c[e]*b[e];
	
	for(j=0; j<(n+m); j++){
		c[j] = c[j] - c[e]*a[e][j];
	}
	
	c[l] = -c[e] * a[e][l];
	
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
	
}

int main(){
	
	int i,e,l;
	unesiPodatke();
	while((e = nadjiUlaz())!=-1){
		l = nadjiIzlaz(e);
		if(l==-1){
			printf("Nemoguce");
			break;
		}
		pivot(e,l);
	}
	
	if(e!=-1){
		for(i=0; i<(n+m); i++){
			if(BN[i] == SKUP_N){
				x[i] = b[i];
			}else{
				x[i] = 0;
			}
		}
	}
	
	/*for(i=0; i<(n+m); i++){
		printf("%8.5lf ",b[i]);
	}
	
	printf("\n\n");
	for(i=0; i<(n+m); i++){
		printf("%8.5lf ",c[i]);
	}*/
	
	printf("%.2lf\n",v);
	for(i=0; i<(n+m); i++){
		if(BN[i] == SKUP_N){
			printf("%4.2lf ",x[i]);
		}	
	}
	
	
	
	return 0;
}



























