#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0


int m, n;

double **a;
double *b;
double *c;
double *x;
int *BN;

double v;

void UnesiPodatke(){
    double d1Sljiva, d1Kajsija, d1Visnja, d1Secer;
    double d2Sljiva, d2Kajsija, d2Secer;
    double d3Sljiva, d3Visnja, d3Secer;
    double d4Visnja, d4Kajsija, d4Secer;
    double secer;
    double sljiva;
    double kajsija;
    double visnja;
    double cenaD1, cenaD2, cenaD3, cenaD4;
    double budzet;
    double trosakD1, trosakD2, trosakD3, trosakD4;
    int i;

    m = 5;
    n = 4;

    a = (double**)malloc(sizeof(double*) * (n + m));
    for(i = 0; i < n + m; i++)
        a[i] = (double*)malloc(sizeof(double) * (n + m));
    b = (double*)malloc(sizeof(double) * (n + m));;
    c = (double*)malloc(sizeof(double) * (n + m));;
    x = (double*)malloc(sizeof(double) * (n + m));
    BN = (int*)malloc(sizeof(int) * (n + m));

    for(i = 0; i < n; i++){
        BN[i] = SKUP_N;
        b[i] = 0;
    }

    for(i = n; i < n + m; i++){
        BN[i] = SKUP_B;
        c[i] = 0;
    }

    scanf("%lf%lf%lf%lf", &d1Sljiva, &d1Kajsija, &d1Visnja, &d1Secer);
    scanf("%lf%lf%lf", &d2Sljiva, &d2Kajsija, &d2Secer);
    scanf("%lf%lf%lf", &d3Sljiva, &d3Visnja, &d3Secer);
    scanf("%lf%lf%lf", &d4Kajsija, &d4Visnja, &d4Secer);
    scanf("%lf", &secer);
    scanf("%lf", &sljiva);
    scanf("%lf", &kajsija);
    scanf("%lf", &visnja);
    scanf("%lf%lf%lf%lf", &cenaD1, &cenaD2, &cenaD3, &cenaD4);
    scanf("%lf", &budzet);
    scanf("%lf%lf%lf%lf", &trosakD1, &trosakD2, &trosakD3, &trosakD4);

    a[n][0] = d1Sljiva;
    a[n][1] = d2Sljiva;
    a[n][2] = d3Sljiva;
    a[n][3] = 0.0;
    b[n] = sljiva;

    a[n+1][0] = d1Kajsija;
    a[n+1][1] = d2Kajsija;
    a[n+1][2] = 0.0;
    a[n+1][3] = d4Kajsija;
    b[n+1] = kajsija;

    a[n+2][0] = d1Visnja;
    a[n+2][1] = 0.0;
    a[n+2][2] = d3Visnja;
    a[n+2][3] = d4Visnja;
    b[n+2] = visnja;

    a[n+3][0] = d1Secer;
    a[n+3][1] = d2Secer;
    a[n+3][2] = d3Secer;
    a[n+3][3] = d4Secer;
    b[n+3] = secer;

    a[n+4][0] = trosakD1;
    a[n+4][1] = trosakD2;
    a[n+4][2] = trosakD3;
    a[n+4][3] = trosakD4;
    b[n+4] = budzet;


    c[0] = cenaD1 - trosakD1;
    c[1] = cenaD2 - trosakD2;
    c[2] = cenaD3 - trosakD3;
    c[3] = cenaD4 - trosakD4;

    v = 0.0;
}


int NadjiUlaz(){
    int i;

    int e = -1;
    for(i = 0; i < n + m; i++)
        if(BN[i] == SKUP_N && c[i] > 0){
            e = i;
            break;
        }
    return e;
}

int NadjiIzlaz(int e){
    int i;
    double min;

    int l = -1;
    for(i = 0; i < n + m; i++)
        if(BN[i] == SKUP_B && a[i][e] > 0){
            if(l == -1){
                min = b[i] / a[i][e];
                l = i;
            }
            else{
                if(b[i] / a[i][e] < min){
                   min = b[i] / a[i][e];
                    l = i; 
                }
            }
        }
    return l;
}

void pivot(int e, int l){
    int i, j;

    b[e] = b[l] / a[l][e];
    for(i = 0; i < n + m; i++)
        if(BN[i] == SKUP_N && i != e)
            a[e][i] = a[l][i] / a[l][e];
    a[e][l] = 1 / a[l][e];

    for(i = 0; i < n + m; i++)
        if(BN[i] == SKUP_B && i != l){
            b[i] = b[i] - a[i][e] * a[e][l];
            for(j = 0; j < n + m; j++)
                if(BN[j] == SKUP_N && j != e)
                    a[i][j] = a[i][j] - a[i][e] * a[e][j];
            a[i][l] = -a[i][e] * a[e][l];
        }

    v = v + c[e] * b[e];
    for(i = 0; i < n + m; i++)
        if(BN[i] == SKUP_N && i != e)
            c[i] = c[i] - c[e] * a[e][i];
    c[l] = -c[e] * a[e][l];

    BN[e] = SKUP_B;
    BN[l] = SKUP_N;
}

main(){
    int i;
    int e, l;

    UnesiPodatke();

    while((e = NadjiUlaz()) != -1){
        l = NadjiIzlaz(e);

        if(l == -1){
            printf("Problem neodredjen.\n");
            break;
        }
        else
            pivot(e, l);
    }

    if(e == -1){
        for(i = 0; i < n; i++)
            if(BN[i] == SKUP_B)
                x[i] = b[i];
            else
                x[i] = 0;

        printf("%.2lf\n", v);
        for(i = 0; i < n; i++)
            printf("%.2lf ", x[i]);
        printf("\n");
    }
}