#include<stdio.h>
#include<stdlib.h>
#define skupB 1
#define skupN 0

double **a,*b,*c,*x,v;
int m,n,*BN;

void ucitajPodatke()
{
	int i;
	m=5; //broj nejednacina
	n=4; //broj nepoznatih
	
	a=(double**)malloc((n+m)*sizeof(double*));
	for(i=0;i<n+m;i++)
	a[i]=(double*)malloc((n+m)*sizeof(double));
	
	
	b=(double*)malloc((n+m)*sizeof(double));
	c=(double*)malloc((n+m)*sizeof(double));
	x=(double*)malloc((n+m)*sizeof(double));
	BN=(int*)malloc((n+m)*sizeof(int));
	
	double dzem1Sljiva,dzem1kajsija,dzem1visnja,dzem1secer;
	double dzem2sljiva,dzem2kajsija,dzem2secer;
	double dzem3sljiva,dzem3visnja,dzem3secer;
	double dzem4kajsija,dzem4visnja,dzem4secer;
	
	double secer,sljiva,kajsija,visnja;
	double cena1,cena2,cena3,cena4;
		
	double budzet;
	double trosak1,trosak2,trosak3,trosak4;
	
	scanf("%lf%lf%lf%lf",&dzem1Sljiva,&dzem1kajsija,&dzem1visnja,&dzem1secer);
	scanf("%lf%lf%lf",&dzem2sljiva,&dzem2kajsija,&dzem2secer);
	scanf("%lf%lf%lf",&dzem3sljiva,&dzem3visnja,&dzem3secer);
	scanf("%lf%lf%lf",&dzem4kajsija,&dzem4visnja,&dzem4secer);
	
	scanf("%lf%lf%lf%lf",&secer,&sljiva,&kajsija,&visnja);
	scanf("%lf%lf%lf%lf", &cena1,&cena2,&cena3,&cena4);
	
	scanf("%lf",&budzet);
	scanf("%lf%lf%lf%lf",&trosak1,&trosak2,&trosak3,&trosak4);
	
	
	c[0]=cena1-trosak1; //na svaki prodati kilogram ide i cena po kg za trosak, pa se zarada umanjuje 
	c[1]=cena2-trosak2;
	c[2]=cena3-trosak3;
	c[3]=cena4-trosak4;
	
	a[n][0]=dzem1Sljiva; a[n][1]=dzem2sljiva; a[n][2]=dzem3sljiva; a[n][3]=0; b[n]=sljiva;
	
	a[n+1][0]=dzem1kajsija; a[n+1][1]=dzem2kajsija; a[n+1][2]=0; a[n+1][3]=dzem4kajsija; b[n+1]=kajsija;
	
	a[n+2][0]=dzem1visnja; a[n+2][1]=0; a[n+2][2]=dzem3visnja; a[n+2][3]=dzem4visnja; b[n+2]=visnja;
	
	a[n+3][0]=dzem1secer; a[n+3][1]=dzem2secer; a[n+3][2]=dzem3secer; a[n+3][3]=dzem4secer; b[n+3]=secer;
	
	a[n+4][0]=trosak1; a[n+4][1]=trosak2; a[n+4][2]=trosak3; a[n+4][3]=trosak4; b[n+4]=budzet;
	
	for(i=0;i<n;i++)
	{
		BN[i]=skupN;
		b[i]=0;
		}
	for(i=n;i<n+m;i++)
	{
		BN[i]=skupB;
		c[i]=0;
		}
	v=0;	
}

int nadjiUlaz()
{
	int i,e=-1;
	for(i=0;i<n+m;i++)
	if(BN[i]==skupN && c[i] > 0)
	{
		e=i;
		break;
	}
	return e;
}


int nadjiIzlaz(int e)
{
	int l=-1,i;
	double min=-1;

	for(i=0;i<n+m;i++)
	if(BN[i]==skupB && a[i][e]>0)
	{
		if(min==-1 || b[i]/a[i][e]< min)
		{
			min=b[i]/a[i][e];
			l=i;
		}
	}
	return l;
}

void pivot(int pocetak, int kraj)
{
	int i,j;
	
	b[pocetak]=b[kraj]/a[kraj][pocetak];
	
	for(j=0;j<n+m;j++)
	if(BN[j]==skupN && j!=pocetak)
	a[pocetak][j]=a[kraj][j]/a[kraj][pocetak];
	
	a[pocetak][kraj]=1/a[kraj][pocetak];
	
	for(i=0;i<n+m;i++)
	{
	
		if(BN[i]==skupB && i!=kraj)
		{
		b[i]=b[i]-b[pocetak]*a[i][pocetak];
		for(j=0;j<n+m;j++)
		if(BN[j]==skupN && j!= pocetak)
		a[i][j]=a[i][j]-a[i][pocetak]*a[pocetak][j];
		
		a[i][kraj]=-a[i][pocetak]*a[pocetak][kraj];
		}
	
	}
	
	v=v+c[pocetak]*b[pocetak];
	
	for(j=0;j<n+m;j++)
	if(BN[j]==skupN && j!=pocetak)
	c[j]=c[j]-c[pocetak]*a[pocetak][j];
	
	c[kraj]=-c[pocetak]*a[pocetak][kraj];
	BN[pocetak]=skupB;
	BN[kraj]=skupN;
}

int main()
{
	int i,l,e;
	
	ucitajPodatke();
	
	while((e=nadjiUlaz()) != -1)
	{
		l=nadjiIzlaz(e);
		if(l==-1)
		{
			printf("Problem neogranicen\n");
			return 0;
			}
		else
		pivot(e,l);
	}
	
	if(e==-1)
	{
		printf("\n%.2lf\n",v);
		
		for(i=0;i<n;i++)
		if(BN[i]==skupB)
		x[i]=b[i];
		else
		x[i]=0;
		
	for(i=0;i<n;i++)
	printf("%.2lf ",x[i]); 	
	}
	
	return 0;
	}

