#include<stdio.h>
#include<stdlib.h>
#define AUTOPUT 1
#define REGIONALNI 0
#define INF -1
#define NEDEFINISANO -2
#define TRUE 1
#define FALSE 0

double s=0;

double manje(double x, double y)
{
	if(x==INF) return FALSE;
	if(y==INF) return TRUE;
	return x<y;
	}

void rekonstrukcija(int **pret, int poc, int tren,int *br)
{
	if(poc==tren)
	{ printf("%d ", tren); 
		(*br)++;
		}
	else
	{
		rekonstrukcija(pret,poc,pret[poc][tren],br);
		printf("%d ", tren);
		(*br)++;
	}
}

void ubaciUNiz(int *niz,int **pret, int poc, int kraj,int *br)
{
	if(poc==kraj)
	niz[(*br)++]=kraj;
	else
	{
			ubaciUNiz(niz,pret,poc,pret[poc][kraj],br);
			niz[(*br)++]=kraj;
		}
	
} 

int main()
{
	double cenaGoriva;
	double potrosnjaAutoPut,potrosnjaRegionalni;
	int n,m;
	double **graf,**rast,**put;
	int **pret;
	int u,v,oznaka;
	double duzina,w;
	double cenaPutarine;
	int polaziste,odrediste;
	int i,j,k;
	
	scanf("%lf",&cenaGoriva);
	scanf("%lf%lf",&potrosnjaRegionalni,&potrosnjaAutoPut);
	scanf("%d%d",&n,&m);
	
	graf=(double**)malloc(n*sizeof(double*));
	rast=(double**)malloc(n*sizeof(double*));
	pret=(int**)malloc(n*sizeof(int*));
	put=(double**)malloc(n*sizeof(double));
	for(i=0;i<n;i++)
	{
		graf[i]=(double*)malloc(n*sizeof(double));
		rast[i]=(double*)malloc(n*sizeof(double));
		pret[i]=(int*)malloc(n*sizeof(int));
		put[i]=(double*)malloc(n*sizeof(double));
	}
	
	
	for(i=0;i<n;i++)
	for(j=0;j<n;j++)
	{
		graf[i][j]=INF;
		rast[i][j]=INF;
		pret[i][j]=NEDEFINISANO;
		put[i][j]=INF;
		}		
		
		/*
	putchar(10);	
		for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		printf("%.2lf ", rast[i][j]);		
		
		printf("\n");
		}	
	
	*/
	
	for(i=0;i<m;i++)
	{
		scanf("%d%d%lf%d",&u,&v,&duzina,&oznaka);
		
		//printf("%d %d %lf %d \n",u,v,duzina,oznaka);
		
		if(oznaka==AUTOPUT){
		scanf("%lf",&cenaPutarine);
		w=duzina*cenaGoriva*potrosnjaAutoPut/100; //potrosnja u l po km
		w+=cenaPutarine;
		}
		else if(oznaka==REGIONALNI)  
		w=duzina*cenaGoriva*potrosnjaRegionalni/100;
	
	if(graf[u][v]==INF)
	{
		graf[u][v]=graf[v][u]=w;
		rast[u][v]=rast[v][u]=w;
		pret[u][v]=u;
		pret[v][u]=v;
		put[u][v]=put[v][u]=duzina;
		}
	
	else if(graf[u][v] != INF)	
	{	if(graf[u][v] > w)
		{
		graf[u][v]=graf[v][u]=w;
		rast[u][v]=rast[v][u]=w;
		pret[u][v]=u;
		pret[v][u]=v;
		put[u][v]=put[v][u]=duzina;		
		}
	}
	}
	/*
	putchar(10);	
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		printf("%.2lf ", rast[i][j]);		
		
		printf("\n");
		}	
	
	*/
	
	scanf("%d%d", &polaziste,&odrediste);
	
	
	for(k=0;k<n;k++)
	for(i=0;i<n;i++)
	for(j=0;j<n;j++)
	{
		if(i!=j && j!=k && i!=k)
		if(rast[i][k]!=INF && rast[k][j]!=INF)
		if(manje(rast[i][k]+rast[k][j],rast[i][j]))
		{
			rast[i][j]=rast[i][k]+rast[k][j];
			pret[i][j]=pret[k][j];
			put[i][j]=put[i][k]+put[k][j];
			}
		
	}
	
	//printf("%lf", rast[polaziste][odrediste]);
	
	/*
	putchar(10);
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		printf("%.2lf ", rast[i][j]);		
		
		printf("\n");
		}	*/
	
	
	int br=0;
	
	rekonstrukcija(pret,polaziste,pret[polaziste][odrediste],&br);	
	//printf("%d\n",br);
	
	int *niz;
	niz=(int*)malloc(br*sizeof(int));
	int b=0;
	ubaciUNiz(niz,pret,polaziste,odrediste,&b);
	
	/*
	for(i=0;i<br;i++)
	printf("%d ", niz[i]);*/
	
	
	double **graf2,**put2;
	int **pret2;
	
	graf2=(double**)malloc(n*sizeof(double*));
	for(i=0;i<n;i++)
	graf2[i]=(double*)malloc(n*sizeof(double));
	
	put2=(double**)malloc(n*sizeof(double*));
	for(i=0;i<n;i++)
	put2[i]=(double*)malloc(n*sizeof(double));
	
	pret2=(int**)malloc(n*sizeof(int*));
	for(i=0;i<n;i++)
	pret2[i]=(int*)malloc(n*sizeof(int));
	
	
	for(i=0;i<n;i++)
	for(j=0;j<n;j++)
	{
	graf2[i][j]=graf[i][j];
	pret2[i][j]=pret[i][j];
	put2[i][j]=put[i][j];}
	
	/*
	putchar(10);	
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		printf("%.2lf ", graf2[i][j]);		
		
		printf("\n");
		}	
	
	*/
	for(i=0;i<br-1;i++)
	{
		u=niz[i];
		v=niz[i+1];
		
		//printf("%d %d\n", u,v);
		graf2[u][v]=graf2[v][u]=-1;
		pret2[u][v]=pret[v][u]=NEDEFINISANO;
		put2[u][v]=put2[v][u]=INF;
		}
	
	/*putchar(10);	
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		printf("%.2lf ", graf2[i][j]);		
		
		printf("\n");
		}	
	*/
	
	for(k=0;k<n;k++)
	for(i=0;i<n;i++)
	for(j=0;j<n;j++)
	{
		if(i!=j && j!=k && i!=k)
		if(graf2[i][k]!=INF && graf2[k][j]!=INF)
		if(manje(graf2[i][k]+graf2[k][j],graf2[i][j]))
		{
			graf2[i][j]=graf2[i][k]+graf2[k][j];
			pret2[i][j]=pret2[k][j];
			put2[i][j]=put2[i][k]+put2[k][j];
			}
		
	}
	
	//putchar(10);
	int brr=0;
	rekonstrukcija(pret2,odrediste,polaziste,&brr);
	//printf("%lf",2*rast[polaziste][odrediste]);
	
	double putS;
	
	putS=put[polaziste][odrediste] + put2[odrediste][polaziste];
	
	double suma=0;
	suma=rast[polaziste][odrediste]  + graf2[odrediste][polaziste];
	printf("\n\n%lf\n", suma);
	printf("\n%lf\n", putS);
	return 0;
}
