#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

int n,m, *BN;
double **a,*b,*c,*x, v;

void UnesiPodatke() {
	n = 4;
	m = 4 ;
	int i;
	
	BN = (int*)malloc(sizeof(int)*(n+m));
	a = (double**)malloc(sizeof(double*)*(n+m));
	for(i=0;i<n+m;i++) {
		a[i] = (double*)malloc(sizeof(double)*(n+m));
	}
	
	b = (double *)malloc(sizeof(double)*(n+m));
	c = (double *)malloc(sizeof(double)*(n+m));
	x = (double *)malloc(sizeof(double)*(n+m));
	
	double dzem1Sl, dzem1K, dzem1V,dzem1S;
	scanf("%lf%lf%lf%lf", &dzem1Sl, &dzem1K, &dzem1V, &dzem1S);
	double dzem2Sl, dzem2K, dzem2S;
	scanf("%lf%lf%lf", &dzem2Sl, &dzem2K, &dzem2S);
	double dzem3Sl, dzem3V, dzem3S;
	scanf("%lf%lf%lf", &dzem3Sl, &dzem3V, &dzem3S);
	double dzem4K, dzem4V, dzem4S;
	scanf("%lf%lf%lf", &dzem4K, &dzem4V, &dzem4S);
	
	double secer, sljiva,kajsija,visnja;
	scanf("%lf%lf%lf%lf", &secer, &sljiva, &kajsija,&visnja);
	
	double dzem1C, dzem2C, dzem3C,dzem4C;
	scanf("%lf%lf%lf%lf", &dzem1C, &dzem2C, &dzem3C, &dzem4C);
	
	double budzet, trosak1, trosak2, trosak3, trosak4;
	scanf("%lf%lf%lf%lf%lf", &budzet, &trosak1, &trosak2, &trosak3, &trosak4);
	
	for(i=0;i<n;i++) {
		b[i] = 0;
		BN[i] = SKUP_N;
		
	}
	for(i=n;i<n+m;i++ ) {
		BN[i] = SKUP_B;
		c[i] = 0;
	}
	
	c[0] = (dzem1C-trosak1), c[1] = (dzem2C - trosak2), c[2]= (dzem3C-trosak3), c[3] = (dzem4C - trosak4);
	
	b[n] = sljiva, b[n+1] = kajsija; b[n+2] = visnja, b[n+3] = secer, b[n+4] = budzet;
	
	a[n][0] = dzem1Sl;
	a[n][1] = dzem2Sl;
	a[n][2] = dzem3Sl;
	a[n][3] = 0;
	
	a[n+1][0] = dzem1K;
	a[n+1][1] = dzem2K;
	a[n+1][2] = 0;
	a[n+1][3] = dzem4K;
	
	a[n+2][0] = dzem1V;
	a[n+2][1] = 0;
	a[n+2][2] = dzem3V;
	a[n+2][3] = dzem4V;
	
	a[n+3][0] = dzem1S;
	a[n+3][1] = dzem2S;
	a[n+3][2] = dzem3S;
	a[n+3][3] = dzem4S;
	
	a[n+4][0] = trosak1;
	a[n+4][1] = trosak2;
	a[n+4][2] = trosak3;
	a[n+4][3] = trosak4;
	
	
	v=0;
}

int nadjiUlaz() {
	int e=-1,i;
	
	for(i=0;i<n+m;i++) {
		if(BN[i] == SKUP_N && c[i] > 0) {
			e = i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e) {
	int i, l=-1;
	double min;
	for(i=0;i<n+m;i++) {
		if(BN[i] == SKUP_B && a[i][e] > 0) {
			if(l==-1) {
				min = b[i] / a[i][e];
				l = i;
				
			}else {
				if(b[i]/a[i][e] < min) {
					min = b[i]/a[i][e];
					l = i;
				}
			}
		}
	}
	return l;
}


void pivot(int e, int l) {
	int i, j;
	b[e] = b[l]/a[l][e];
	for(i=0;i<n+m;i++) {
		if(BN[i] == SKUP_N && i !=e ) {
			a[e][l] = a[l][i] /a[l][e];
		}
	}
	
	a[e][l] = 1/a[l][e];
	
	for(i=0;i<n+m;i++) {
		if(BN[i] == SKUP_B && i !=l) {
			b[i] = b[i] - a[i][e]*b[e];
		}
		for(j=0;j<n+m;j++) {
			if(BN[j] == SKUP_N && j!=e) {
				a[i][j] = a[i][j] - a[i][e]*a[e][j];
			}
			
		}
		a[i][l] = -a[i][e]*a[e][l];
	}
	
	v= v+c[e]*b[e];
	
	for(j=0;j<n+m;j++) {
		if(BN[j] == SKUP_N && j!= e) {
			c[j] = c[j] - c[e]*a[e][j];
		}
	}
	c[l] = -c[e]*a[e][l];
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main() {
	int i,j, e,l;
	UnesiPodatke();
	while ((e=nadjiUlaz())!= -1) {
		l = nadjiIzlaz(e);
		if(l==-1) {
			printf("Problem neogranicen\n");
			break;
		}else {
			pivot(e,l);
		}
	}
	if(e==-1) {
		printf("%lf ",v);
		for(j=0;j<n;j++) {
			if(BN[j] == SKUP_B) {
				x[j] = b[j];
			} else {
				x[j] = 0;
			}
		}
		for(j=0;j<n;j++) {
			printf("%lf ",x[j]);
		}
		
	}
}
