#include <stdio.h>
#include <stdlib.h>

#define INF 9999

void ispisPuta(int *prethodnik, int odr) {
	if(odr == -1)
		return;
	ispisPuta(prethodnik, prethodnik[odr]);
	printf("%d ", odr);
}


void dijkstra(int n, double **graf, double **d, int **prethodnik, int pocetak, int **markiran) {
	int *obidjen, i,j, u;
	obidjen = (int*)malloc(sizeof(int)*n);
	
	for(i=0;i<n;i++) {
		obidjen[i] = 0;
		(*d)[i] = INF;
		(*prethodnik)[i] = -1;
	}
	
	(*d)[pocetak] = 0;
	
	for(i=0;i<n;i++) {
		u = -1;
		for(j=0;j<n;j++) {
			if(obidjen[j])
				continue;
			if((*markiran)[j])
				continue;
			if(u == -1 || (*d)[j] < (*d)[u]) {
				u = j;
			}
		}
		
		for(j=0;j<n;j++) {
			if(obidjen[j])
				continue;
			if((*markiran)[j])
				continue;
			if((*d)[j] > (*d)[u] + graf[u][j])  {
				(*d)[j] = (*d)[u] + graf[u][j];
				(*prethodnik)[j] = u;
				(*markiran)[j] = 1;
			}
			
		}
		
		obidjen[u] = 1;
	}

}

int main() {
	double cenaGoriva, potrosnjaGorivaA, potrosnjaGorivaR;
	int n,m, i, j, u,v,l,tip, putarina, pol, odr;
	double **graf,**grafA,**grafR, *d, **grafKMA;
	
	int *prethodnik;
	scanf("%lf %lf %lf", &cenaGoriva, &potrosnjaGorivaA, &potrosnjaGorivaR);
	
	scanf("%d%d", &n,&m);
	
	graf= (double**)malloc(sizeof(double*)*n); 
	grafA = (double**)malloc(sizeof(double*)*n); 
	grafR = (double**)malloc(sizeof(double*)*n); 
	grafKMA = (double**)malloc(sizeof(double*)*n);
	prethodnik = (int*)malloc(sizeof(int)*n);
	d = (double*)malloc(sizeof(double)*n);
	 
	for(i=0;i<n;i++) {
		graf[i] = (double*)malloc(sizeof(double)*n);
		grafA[i] = (double*)malloc(sizeof(double)*n);
		grafR[i] = (double*)malloc(sizeof(double)*n); 
		grafKMA[i] = (double*)malloc(sizeof(double)*n); 
		for(j=0;j<n;j++) {
			graf[i][j] = INF;
			grafA[i][j] = -1;
			grafR[i][j] = -1;
			//grafK[i][j] = INF;
		}
	}
	
	
	
	for(i=0;i<m;i++) {
		scanf("%d%d%d%d", &u,&v,&l,&tip);
		
		if(tip == 1) {
			scanf("%d ", &putarina);
			grafKMA[u][v] = l;
			grafKMA[v][u] = l;
			l = l/100*potrosnjaGorivaA*cenaGoriva+ putarina;
			grafA[u][v] = l;
			grafA[v][u] = l;  
		} else {
			l = l/100*potrosnjaGorivaA*cenaGoriva;
			grafR[u][v] = l;
			grafR[v][u] = l;
		}
		
		if(grafA[u][v]!= -1 && grafR[u][v]!=-1 && grafA[u][v] <= grafR[u][v]) {
			graf[u][v] = grafA[u][v];
			graf[v][u] = grafA[u][v];
			
		} else {
			graf[u][v] = grafR[u][v];
			graf[v][u] = grafR[u][v];
			
		}
		
	}
	
	/*for(i=0;i<n;i++) {
		for(j=0;j<n;j++) {
			printf("%.1lf ", grafA[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	
	for(i=0;i<n;i++) {
		for(j=0;j<n;j++) {
			printf("%.1lf ", grafR[i][j]);
		}
		printf("\n");
	}*/
	
	
	/*for(i=0;i<n;i++) {
		for(j=0;j<n;j++) {
			printf("%.1lf ", graf[i][j]);
		}
		printf("\n");
	}*/
	
	
	
	
	scanf("%d%d",&pol,&odr);
	
	int *markiran;
	markiran = (int*)malloc(sizeof(int)*n);
	for(i=0;i<n;i++) 
		markiran[i] = 0;
		
	double ukupnaCena = 0;
	
	dijkstra(n,graf,&d,&prethodnik,pol, &markiran);
	
	ukupnaCena += d[odr];
	for(i=0;i<n;i++)  {
		printf("%d %d %.1lf\n ",i,prethodnik[i], d[i]);
	}
	printf("\n");
	
	ispisPuta(prethodnik,odr);
	dijkstra(n,graf,&d,&prethodnik,odr, &markiran);
	ispisPuta(prethodnik,pol);
	ukupnaCena += d[pol];


	printf("%.1lf\n",ukupnaCena);
	return 0;

}
