#include<stdio.h>
#include <stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

double **a;
double *x,*c,*b;
int *BN;
int n,m, v;

double *AlocirajNizDOUBLE(int n)
{
    return (double*) malloc(n * sizeof(double));
}

void Alociraj()
{
    a = (double**) malloc(n * sizeof(double*));

    for(int i = 0; i < n + m; i++)
    {
        a[i] = AlocirajNizDOUBLE(n + m);
    }

    x = AlocirajNizDOUBLE(n + m);
    c = AlocirajNizDOUBLE(n + m);
    b = AlocirajNizDOUBLE(n + m);
}

void UnostPodataka()
{
    n = 4;
    m = 7;

    Alociraj();

    double *dzem1 = AlocirajNizDOUBLE(n); // 0-> sljiva, 1-> kajsija,  2 -> visnja, 3-> secer
    double *dzem2 = AlocirajNizDOUBLE(n); // 0-> sljiva, 1-> kajsija,  2 -> visnja, 3-> secer
    double *dzem3 = AlocirajNizDOUBLE(n);// 0-> sljiva, 1-> kajsija,  2 -> visnja, 3-> secer
    double *dzem4 = AlocirajNizDOUBLE(n);// 0-> sljiva, 1-> kajsija,  2 -> visnja, 3-> secer

    //Ucitavanje dzem 1
    for(int i = 0 ; i < n; i++)
    {
        scanf("%lf",&dzem1[i]);
    }

    //Ucitavanje dzem 2
    scanf("%lf",&dzem1[0]);
    scanf("%lf",&dzem1[1]);
    dzem1[3] = 0;
    scanf("%lf",&dzem1[3]);

    //Ucitavanje dzem 3
    scanf("%lf",&dzem1[0]);
    dzem1[1] = 0;
    scanf("%lf",&dzem1[2]);
    scanf("%lf",&dzem1[3]);

    //Ucitavanje dzem 4
    dzem1[0] = 0;
    scanf("%lf",&dzem1[1]);
    scanf("%lf",&dzem1[2]);
    scanf("%lf",&dzem1[3]);

    double ukupnoSecer, ukupnoSljiva, ukupnoKajsija, ukupnoVisnja;
    double *cene = AlocirajNizDOUBLE(n);

    scanf("%lf",&ukupnoSecer);
    scanf("%lf",&ukupnoSljiva);
    scanf("%lf",&ukupnoKajsija);
    scanf("%lf",&ukupnoVisnja);

    //Ucitavanje cena
    for(int i = 0 ; i < n; i++)
    {
        scanf("%lf",&cene[i]);
    }

    double ukupanBudzet;
    scanf("%lf",&ukupanBudzet);
    double *troskovi = AlocirajNizDOUBLE(n);

    //Ucitavanje troskova
    for(int i = 0 ; i < n; i++)
    {
        scanf("%lf",&troskovi[i]);
    }

    for(int i = 0; i < n; i++)
    {
        c[i] = cene[i];
        BN[i] = SKUP_N;
    }

    b[n] = ukupnoSljiva;
    b[n + 1] = ukupnoKajsija;
    b[n + 2] = ukupnoVisnja;
    b[n + 3] = ukupnoSecer;

    for(int i = n; i < n+m; i++)
    {
        BN[i] = SKUP_B;
    }

    a[n][0] = dzem1[0];
    a[n][1] = dzem2[0];
    a[n][2] = dzem3[0];
    a[n][3] = dzem4[0];

    a[n + 1][0] = dzem1[1];
    a[n + 1][1] = dzem2[1];
    a[n + 1][2] = dzem3[1];
    a[n + 1][3] = dzem4[1];

    a[n + 2][0] = dzem1[2];
    a[n + 2][1] = dzem2[2];
    a[n + 2][2] = dzem3[2];
    a[n + 2][3] = dzem4[2];

    a[n + 3][0] = dzem1[3];
    a[n + 3][1] = dzem2[3];
    a[n + 3][2] = dzem3[3];
    a[n + 3][3] = dzem4[3];

    b[n + 4] = ukupanBudzet;
    a[n + 4][0] = troskovi[0];
    a[n + 4][1] = 0;
    a[n + 4][2] = 0;
    a[n + 4][3] = 0;

    b[n + 5] = ukupanBudzet;
    a[n + 5][0] = 0;
    a[n + 5][1] = troskovi[1];
    a[n + 5][2] = 0;
    a[n + 5][3] = 0;

    b[n + 6] = ukupanBudzet;
    a[n + 6][0] = 0;
    a[n + 6][1] = 0;
    a[n + 6][2] = troskovi[2];
    a[n + 6][3] = 0;

    b[n + 7] = ukupanBudzet;
    a[n + 7][0] = 0;
    a[n + 7][1] = 0;
    a[n + 7][2] = 0;
    a[n + 7][3] = troskovi[3];

    v = 0;
}

int NadjiUlaz()
{
    int e = -1;

    for(int i = 0; i < n; i++)
    {
        if(BN[i] == SKUP_N && c[i] > 0)
        {
            e = i;
            break;
        }
    }

    return e;
}

int NadjiIzlaz(int e)
{
    int l = -1;
    double min;

    for(int i = 0; i < n+m; i++)
    {
        if(BN[i] == SKUP_B && a[i][e] >0)
        {
            if(l ==-1)
            {
                min = b[i]/a[i][e];
                l =i;
            }
            else
            {
                if(b[i] / a[i][e] < min)
                {
                    min = b[i] / a[i][e];
                    l = i;
                }
            }
        }
    }

    return l;
}

void Pivot(int e, int l)
{
    b[e] = b[l] / a[l][e];
    for(int j = 0; j < n + m; j++)
    {
        if(BN[j] == SKUP_N && j!= e)
        {
            a[e][j] = a[l][j] / a[l][e];
        }
    }

    a[e][l] = 1 / a[l][e];
    for(int i = 0; i < n+m; i++)
    {
        if(BN[i] == SKUP_B && i != l)
        {
            b[i] = b[i] - a[i][e] * b[e];
            for(int j = 0; j < n+m; j++)
            {
                if(BN[j] == SKUP_N && j!= e)
                {
                    a[i][j] = a[i][j] - a[i][e] * a[e][j];
                }
            }
            a[i][l] = -a[i][e] * a[e][l];
        }

    }

    v = v + c[e] * b[e];
    for(int j = 0; j < n + m; j++)
    {
        if(BN[j] == SKUP_N && j != e)
        {
            c[j]= c[j] - c[e] * a[e][j];
        }
    }

    c[l] = -c[e] * a[e][l];

    BN[e] = SKUP_B;
    BN[l] = SKUP_N;
}

void Simplex()
{

}

int main()
{

    return 0;
}
