#include<stdio.h>
#include<stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

double **a;
double *b, *c, *x;
int *NB;
int n,m;
double v;

void unesiPodatke()
{
	int i;
	n=4;
	m=5;
	
	a = (double**)malloc((n+m+1)*sizeof(double*));
	b= (double*)malloc((n+m+1)*sizeof(double));
	c= (double*)malloc((n+m+1)*sizeof(double));
	x= (double*)malloc((n+m+1)*sizeof(double));
	
	NB = (int*)malloc((n+m+1)*sizeof(int));
	
	for(i=1;i<=n+m; i++)
		a[i] = (double*)malloc((n+m+1)*sizeof(double));
	
	for(i=1;i<=n;i++)
	{
		NB[i] = SKUP_N;
		b[i] = 0.0;
	}
	
	for(i=n;i<=n+m;i++)
	{
		NB[i] = SKUP_B;
		c[i]=0.0;
	}
	
	double secer, sljiva, kajsija, visnja, budzet;
	
	//sljiva1 kajsija2 visnja3 secer4

	//sljiva
	scanf("%lf%lf%lf%lf", &a[n+1][1], &a[n+2][1], &a[n+3][1], &a[n+4][1]);
	
	//kajsija	
	scanf("%lf%lf%lf", &a[n+1][2], &a[n+2][2], &a[n+4][2]);
	a[n+3][2]=0;
	
	//visnja
	scanf("%lf%lf%lf", &a[n+1][3], &a[n+3][3], &a[n+4][3]);
	a[n+2][3]=0;
	
	//secer
	scanf("%lf%lf%lf", &a[n+2][4], &a[n+3][4], &a[n+4][4]);
	a[n+1][4]=0;
	
	
	scanf("%lf%lf%lf%lf",&secer, &sljiva, &kajsija, &visnja);
	b[n+1]=sljiva; b[n+2]= kajsija; b[n+3] = visnja; b[n+4] = secer;
	
	double cena1,cena2,cena3,cena4;
	scanf("%lf%lf%lf%lf",&cena1, &cena2, &cena3, &cena4);
	
	scanf("%lf",&budzet);
	
	double trosak1, trosak2, trosak3,trosak4;
	scanf("%lf%lf%lf%lf", &trosak1, &trosak2, &trosak3,&trosak4);
	a[n+5][1]=trosak1; a[n+5][2]=trosak2; a[n+5][3]=trosak3; a[n+5][4]=trosak4;
	
	//c[1] = cena1; c[2]=cena2; c[3]=cena3; c[4]=cena4;
	c[1] = cena1-trosak1; c[2]=cena2-trosak2; c[3]=cena3-trosak3; c[4]=cena4-trosak4;
	
	b[n+5]=budzet;
	
	
	v=0.0;
}
int nadjiUlaz()
{
	int e=-1;
	int i;
	for (i = 1; i <= n+m; i++)
	{
		if(NB[i] == SKUP_N)
		{
			if(c[i]>0)
			{
				e=i;
				break;
			}
		}
	}
	return e;
	
}

int nadjiIzlaz(int e)
{
	int l=-1;
	double min = -1;
	for(int i=1; i<= n+m;i++)
	{
		if(NB[i] == SKUP_B && a[i][e]>0)
		{
			if(min == -1  || (b[i]/a[i][e] < min))
			{
				min =b[i]/a[i][e];
				l=i;
			}
		}
	}
	return l;
}

void pivot(int e, int l)
{
	int i,j;
	b[e] = b[l] / a[l][e];
	a[e][l] = 1/a[l][e];
	
	for(j=1;j<=n+m;j++)
	{
		if(NB[j] == SKUP_N && j!=e)
			a[e][j] = a[l][j]/a[l][e];
	}
	
	for (i = 1; i <=n+m; i++)
	{
		if(NB[i] == SKUP_B && i!=l)
		{
			b[i] = b[i] - a[i][e]*b[e];
			for (j = 1; j <=n+m; j++)
			{
				if(NB[j] == SKUP_N && j!=e)
					a[i][j] = a[i][j]- a[i][e]*a[e][j];
			}
			a[i][l] = -a[i][e]/a[l][e];
		}
	}
	
	
	for(j=1;j<=n+m;j++)
	{
		if(NB[j]==SKUP_N && j!=e)
			c[j] = c[j]-c[e]*a[e][j];
	}
	
	c[l]= -c[e]*a[e][l];
	
	v=v+c[e]*b[e];
	NB[e] = SKUP_B; NB[l] = SKUP_N;
}
int main()
{
	int e,l,i;
	unesiPodatke();
	
	while( (e=nadjiUlaz()) != -1 )
	{
		l=nadjiIzlaz(e);
		
		if(l == -1)
		{
			printf("Neogranicen problem\n");
			break;
		}
		else
			pivot(e,l);
			
	}
	
	if(e==-1)
	{
		printf("%.2lf\n",v);
		
		for (i = 1; i <=n; i++)
		{
			if(NB[i]== SKUP_B)
				x[i] = b[i];
			else
				x[i] = 0;
				
			printf("%.2lf ", x[i]);
		}
		printf("\n");
	}
	return 0;
}
