#include<stdio.h>
#include<stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

int n,m;

double **a;
double *b;
double *c;
double *x;
int *BN;


double v;


void unosPodataka()
{
	int i,j;
	
	n=4;
	m=5;
	
	a=(double **)malloc((n+m)*sizeof(double *));
	for(i=0;i<m+n;i++)
	{
		a[i]=(double *)malloc((m+n)*sizeof(double));
	}
	b=(double *)malloc((m+n)*sizeof(double));
	c=(double *)malloc((m+n)*sizeof(double));
	x=(double *)malloc((n+m)*sizeof(double));
	BN=(int *)malloc((m+n)*sizeof(int));
	
	
	double dzem1Sljiva,dzem1Kajsija,dzem1Visnja,dzem1Secer;
	double dzem2Sljiva,dzem2Kajsija,dzem2Secer;
	double dzem3Sljiva,dzem3Visnja,dzem3Secer;
	double dzem4Kajsija,dzem4Visnja,dzem4Secer;
	double secer,sljiva,kajsija,visnja;
	double cenaDzem1,cenaDzem2,cenaDzem3,cenaDzem4;
	double budzet;
	double trosakDzem1,trosakDzem2,trosakDzem3,trosakDzem4;
	
	scanf("%lf %lf %lf %lf",&dzem1Sljiva,&dzem1Kajsija,&dzem1Visnja,&dzem1Secer);
	scanf("%lf %lf %lf",&dzem2Sljiva,&dzem2Kajsija,&dzem2Secer);
	scanf("%lf %lf %lf",&dzem3Sljiva,&dzem3Visnja,&dzem3Secer);
	scanf("%lf %lf %lf",&dzem4Kajsija,&dzem4Visnja,&dzem4Secer);
	scanf("%lf %lf %lf %lf",&secer,&sljiva,&kajsija,&visnja);
	scanf("%lf %lf %lf %lf",&cenaDzem1,&cenaDzem2,&cenaDzem3,&cenaDzem4);
	scanf("%lf",&budzet);
	scanf("%lf %lf %lf %lf",&trosakDzem1,&trosakDzem2,&trosakDzem3,&trosakDzem4);
	
	
	for(i=0;i<n;i++)
	{
		b[i]=0;
		BN[i]=SKUP_N;
	}
	
	for(i=n;i<m+n;i++)
	{
		c[i]=0;
		BN[i]=SKUP_B;
	}
	
	c[0]=cenaDzem1-trosakDzem1;
	c[1]=cenaDzem2-trosakDzem2;
	c[2]=cenaDzem3-trosakDzem3;
	c[3]=cenaDzem4-trosakDzem4;
	
	b[n]=secer;
	a[n][0]=dzem1Secer;
	a[n][1]=dzem2Secer;
	a[n][2]=dzem3Secer;
	a[n][3]=dzem4Secer;

	b[n+1]=sljiva;
	a[n+1][0]=dzem1Sljiva;
	a[n+1][1]=dzem2Sljiva;
	a[n+1][2]=dzem3Sljiva;
	a[n+1][3]=0;

	b[n+2]=kajsija;
	a[n+2][0]=dzem1Kajsija;
	a[n+2][1]=dzem2Kajsija;
	a[n+2][2]=0;
	a[n+2][3]=dzem4Kajsija;
	
	b[n+3]=visnja;
	a[n+3][0]=dzem1Visnja;
	a[n+3][1]=0;
	a[n+3][2]=dzem3Visnja;
	a[n+3][3]=dzem4Visnja;
		
	
	b[n+4]=budzet;
	a[n+4][0]=trosakDzem1;
	a[n+4][1]=trosakDzem2;
	a[n+4][2]=trosakDzem3;
	a[n+4][3]=trosakDzem4;
	
	
	v=0.0;
	
}

int nadjiUlaz()
{
	int e;
	int i;
	e=-1;
	
	for(i=0;i<n+m;i++)
	{
		if(BN[i]==SKUP_N && c[i]>0)
		{
			e=i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e)
{
	int i;
	int l;
	l=-1;
	double min;
	
	for(i=0;i<m+n;i++)
	{
		if(BN[i]==SKUP_B && a[i][e]>0)
		{
			if(l==-1)
			{
				min=b[i]/a[i][e];
				l=i;
			}
			else
			{
				if(min>b[i]/a[i][e])
				{
					min=b[i]/a[i][e];
					l=i;
				}
			}
		}
	}
	return l;
}

void pivot(int e,int l)
{
	int i,j;
	b[e]=b[l]/a[l][e];
	for(i=0;i<m+n;i++)
	{
		if(BN[i]==SKUP_N && i!=e)
		{
			a[e][i]=a[l][i]/a[l][e];
		}
	}
	a[e][l]=1/a[l][e];

	for(i=0;i<m+n;i++)
	{
		if(BN[i]==SKUP_B && i!=l)
		{
			b[i]=b[i]-b[e]*a[i][e];
			for(j=0;j<m+n;j++)
			{
				if(BN[j]==SKUP_N && j!=e)
				{
					a[i][j]=a[i][j]-a[i][e]*a[e][j];
				}
			}
			a[i][l]=-a[i][e]*a[e][l];
		}
	}

	v=v+b[e]*c[e];
	
	for(i=0;i<m+n;i++)
	{
		if(BN[i]==SKUP_N && i!=e)
		{
			c[i]=c[i]-c[e]*a[e][i];
		}
	}
	c[l]=-c[e]*a[e][l];
	
	BN[e]=SKUP_B;
	BN[l]=SKUP_N;

}

int main()
{
	int e,l;
	int i;

	unosPodataka();
	
	while((e=nadjiUlaz())!=-1)
	{
		l=nadjiIzlaz(e);
		if(l==-1)
		{
			printf("Beskonacno");
			break;
		}else
		{
			pivot(e,l);
		}
	}
	
	if(e==-1)
	{
		for(i=0;i<n;i++)
		{
			if(BN[i]==SKUP_B)
				x[i]=b[i];
			else
				x[i]=0;
		}
	}
	
	
	printf("%.2lf\n",v);
	
	for(i=0;i<n;i++)
		printf("%.2lf ",x[i]);
	printf("\n");
}
