#include <stdio.h>
#include <stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

int m,n;

double **a;
double *b, *c, *x;
double v;

int *BN;

void unosPodataka()
{
	int i,j;

	m=5;
	n=4;

	a = (double **)malloc((m+n)*sizeof(double *));

	for(i=0;i<m+n;i++)
	{
		a[i]=(double *)malloc((m+n)*sizeof(double));
	}

	b = (double *)malloc((m+n)*sizeof(double));
	c = (double *)malloc((m+n)*sizeof(double));
	x = (double *)malloc((m+n)*sizeof(double));
	BN = (int *)malloc((m+n)*sizeof(int));

	double dzem1sljiva, dzem1kajsija, dzem1visnja, dzem1secer;
	double dzem2sljiva, dzem2kajsija, dzem2secer;
	double dzem3sljiva, dzem3visnja, dzem3secer;
	double dzem4kajsija, dzem4visnja, dzem4secer;
	double secer, sljiva, kajsija, visnja;
	double cenaDzem1, cenaDzem2, cenaDzem3, cenaDzem4;
	double budzet;
	double trosakDzem1, trosakDzem2, trosakDzem3, trosakDzem4;

	scanf("%lf%lf%lf%lf", &dzem1sljiva, &dzem1kajsija, &dzem1visnja, &dzem1secer);
	scanf("%lf%lf%lf", &dzem2sljiva, &dzem2kajsija, &dzem2secer);
	scanf("%lf%lf%lf", &dzem3sljiva, &dzem3visnja, &dzem3secer);
	scanf("%lf%lf%lf", &dzem4kajsija, &dzem4visnja, &dzem4secer);
	scanf("%lf", &secer);
	scanf("%lf", &sljiva);
	scanf("%lf", &kajsija);
	scanf("%lf", &visnja);
	scanf("%lf%lf%lf%lf", &cenaDzem1, &cenaDzem2, &cenaDzem3, &cenaDzem4);
	scanf("%lf", &budzet);
	scanf("%lf%lf%lf%lf", &trosakDzem1, &trosakDzem2, &trosakDzem3, &trosakDzem4); 

	c[0] = cenaDzem1 - trosakDzem1;
	c[1] = cenaDzem2 - trosakDzem2;
	c[2] = cenaDzem3 - trosakDzem3;
	c[3] = cenaDzem4 - trosakDzem4;

	for(i=0; i<n; i++)
	{
		BN[i] = SKUP_N;
		b[i]= 0;
	}

	for(j=n; j<m+n; j++)
	{
		BN[j] = SKUP_B;
		c[j] = 0;
	}

	

	a[n][0] = dzem1secer;
	a[n][1] = dzem2secer;
	a[n][2] = dzem3secer;
	a[n][3] = dzem4secer;
	b[n] = secer;

	a[n+1][0] = dzem1sljiva;
	a[n+1][1] = dzem2sljiva;
	a[n+1][2]= dzem3sljiva;
	a[n+1][3]= 0.0;
	b[n+1] =sljiva;

	a[n+2][0] = dzem1kajsija;
	a[n+2][1] = dzem2kajsija;
	a[n+2][2] = 0.0;
	a[n+2][3] = 0.0;
	b[n+2] = kajsija;

	a[n+3][0] = dzem1visnja;
	a[n+3][1] = 0.0;
	a[n+3][2] = dzem3visnja;
	a[n+3][3] = dzem4visnja;
	b[n+3] = visnja;

	a[n+4][0] = trosakDzem1;
	a[n+4][1] = trosakDzem2;
	a[n+4][2] = trosakDzem3;
	a[n+4][3] = trosakDzem4;
	b[n+4] = budzet;

	v=0.0;
}

int nadjiUlaz()
{
	int i;
	int e=-1;

	for(i=0; i<m+n; i++)
	{
		if(BN[i] == SKUP_N && c[i]>0)
		{
			e=i;
			break;
		}
	}

	return e;
}

int nadjiIzlaz(int e)
{
	int i;
	int l=-1;
	double min;

	for(i=0; i<m+n; i++)
	{
		if(BN[i]== SKUP_B && a[i][e]>0)
		{
			if(l==-1)
			{
				l = i;
				min = b[i]/a[i][e];
			}
			else
			{
				if(b[i]/a[i][e] < min)
				{
					l = i;
					min = b[i]/a[i][e];
				}
			}
		}
	}

	return l;
}

void pivot(int e, int l)
{
	int i,j;
	b[e] = b[l]/a[l][e];

	for(j=0; j<m+n;j++)
	{
		if(BN[j]==SKUP_N && j!=e)
		{
			a[e][j] = a[l][j]/a[l][e];
		}
	}
	a[e][l] = 1/a[l][e];

	for(i=0; i<m+n; i++)
	{
		if(BN[i]==SKUP_B && i!=l)
		{
			b[i] = b[i] - a[i][e]*b[e];
			for(j=0; j<m+n; j++)
			{
				if(BN[j]==SKUP_N && j!=e)
				{
					a[i][j] = a[i][j] - a[i][e]*a[e][j];
				}
			}
			a[i][l] = -a[i][e]*a[e][l];
		}
	}

	v = v + c[e]*b[e];

	for(j=0; j<m+n; j++)
	{
		if(BN[j]==SKUP_N && j!=e)
		{
			c[j] =  c[j] - c[e]*a[e][j];
		}
	}

	c[l] =-c[e]*a[e][l];

	BN[e] = SKUP_B;
	BN[l] = SKUP_N;

}

int main()
{
	int e,l;
	int i,j;

	unosPodataka();

	while((e=nadjiUlaz())!=-1)
	{
		l = nadjiIzlaz(e);
		if(l==-1)
		{
			printf("Problem neogranicen!\n");
		}
		else
		{
			pivot(e,l);
		}
	}

	if(e==-1)
	{
		for(j=0; j<n; j++)
		{
			if(BN[j]==SKUP_B)
			{
				x[j] = b[j];
			}
			else
			{
				x[j] = 0;
			}
		}

		printf("%.2lf\n", v);

		for(j=0; j<n; j++)
		{
			printf("%.2lf ", x[j]);
		}
		printf("\n");
	}


	return 0;
}