#include <stdio.h>
#include <stdlib.h>

#define SKUP_N 1
#define SKUP_B 0

double **a, *c, *x, *b, v;
int n, m, *nb;

void unesiPodatke(){
	int i;
	
	n = 4;
	m = 5;
	
	double D1sljiva, D1kajsija, D1visnja, D1secer, D2sljiva, D2kajsija, D2secer;
	double D3sljiva, D3visnja, D3secer, D4kajsija, D4visnja, D4secer;
	double secer, sljiva, kajsija, visnja;
	double cenaD1, cenaD2, cenaD3, cenaD4, budzet, trosakD1, trosakD2, trosakD3, trosakD4;
	
	a = (double**)malloc((n+m+1)*sizeof(double*));
	c = (double*)malloc((n+m+1)*sizeof(double));
	x = (double*)malloc((n+m+1)*sizeof(double));
	b = (double*)malloc((n+m+1)*sizeof(double));
	nb = (int*)malloc((n+m+1)*sizeof(int));
	for(i=1; i<=n+m; i++) a[i] = (double*)malloc((n+m+1)*sizeof(double));
	
	for(i=1; i<=n+m; i++)
		if(i<=n){
			nb[i]=SKUP_N;
			//b[i]=0.0;
			c[i]=0.0;
		}
		else{
			nb[i]=SKUP_B;
			//c[i]=0.0;
			b[i]=0.0;
		}
	
	scanf("%lf%lf%lf%lf", &D1sljiva, &D1kajsija, &D1visnja, &D1secer);
	scanf("%lf%lf%lf", &D2sljiva, &D2kajsija, &D2secer);
	scanf("%lf%lf%lf", &D3sljiva, &D3visnja, &D3secer);
	scanf("%lf%lf%lf", &D4kajsija, &D4visnja, &D4secer);
	scanf("%lf%lf%lf%lf", &secer, &sljiva, &kajsija, &visnja);
	scanf("%lf%lf%lf%lf", &cenaD1, &cenaD2, &cenaD3, &cenaD4);
	scanf("%lf%lf%lf%lf%lf", &budzet, &trosakD1, &trosakD2, &trosakD3, &trosakD4);	
	
	c[n+1]=cenaD1-trosakD1; c[n+2]=cenaD2-trosakD2; c[n+3]=cenaD3-trosakD3; c[n+4]=cenaD4-trosakD4;
	//c[n+1]=cenaD1; c[n+2]=cenaD2; c[n+3]=cenaD3; c[n+4]=cenaD4;
	b[1]=secer; b[2]=sljiva; b[3]=kajsija; b[4]=visnja; b[5]=budzet;
	/*
	a[n+1][n+1]=D1secer;   a[n+1][n+2]=D2secer;   a[n+1][n+3]=D3secer;  a[n+1][n+4]=D4secer;
	a[n+2][n+1]=D1sljiva;  a[n+2][n+2]=D2sljiva;  a[n+2][n+3]=D3sljiva; a[n+2][n+4]=0.0;
	a[n+3][n+1]=D1kajsija; a[n+3][n+2]=D2kajsija; a[n+3][n+3]=0.0;      a[n+3][n+4]=D4kajsija;
	a[n+4][n+1]=D1visnja;  a[n+4][n+2]=0.0;       a[n+4][n+3]=D3visnja; a[n+4][n+4]=D4visnja;
	a[n+5][n+1]=trosakD1;  a[n+5][n+2]=trosakD2;  a[n+5][n+3]=trosakD3; a[n+5][n+4]=trosakD4;
	/*/
	a[n+1][1]=D1secer;   a[n+1][2]=D2secer;   a[n+1][3]=D3secer;  a[n+1][4]=D4secer;
	a[n+2][1]=D1sljiva;  a[n+2][2]=D2sljiva;  a[n+2][3]=D3sljiva; a[n+2][4]=0.0;
	a[n+3][1]=D1kajsija; a[n+3][2]=D2kajsija; a[n+3][3]=0.0;      a[n+3][4]=D4kajsija;
	a[n+4][1]=D1visnja;  a[n+4][2]=0.0;       a[n+4][3]=D3visnja; a[n+4][4]=D4visnja;
	a[n+5][1]=trosakD1;  a[n+5][2]=trosakD2;  a[n+5][3]=trosakD3; a[n+5][4]=trosakD4;
	
	v=0.0;
}

int nadjiUlaz(){
	int i, e=-1;
	for(i=1; i<=n+m; i++)
		if(nb[i]==SKUP_N && c[i]>0){
			e = i;
			break;
		}
	return e;
}

int nadjiIzlaz(int e){
	int i, l=-1;
	double min=-1.0;
	for(i=1; i<=n+m; i++){
		if(nb[i]==SKUP_B && a[i][e]>0)
			if(l==-1 && b[i]/a[i][e]<min){
				min = b[i]/a[i][e];
				l = i;
			}
	}
	return l;
}

void pivot(int e, int l){
	int i, j;
	b[e] = b[e]/a[e][l];
	for(i=1; i<=n+m; i++)
		if(nb[i]==SKUP_N && i!=l)
			b[i] = b[i] - a[i][e]*b[e];
	a[e][l] = 1/a[l][e];
	for(i=1; i<=n+m; i++)
		if(nb[i]==SKUP_B && i!=l){
			b[i] = b[i]-a[i][e]*b[e];
			for(j=1; j<n+m; j++)
				if(nb[j]==SKUP_N && j!=e)
					a[i][j] = a[i][j]-a[e][l]*a[l][e];
			a[i][e] = -a[e][l]*c[e];
		}		
	for(j=1; j<n+m; j++)
		if(nb[j]==SKUP_B && j!=e)
			c[j] = c[j]-b[e]*c[e];
	v = v + c[e]*b[e];
	nb[e] = SKUP_B;
	nb[l] = SKUP_N;
}

int main(){
	int i, e, l;
	double ukupniTroskovi=0.0;

	unesiPodatke();
	
	while((e=nadjiUlaz())!=-1){
		l=nadjiIzlaz(e);
		if(l==-1){
			printf("Neograniceni problem.\n");
			break;
		}
		else pivot(e,l);
	}
	
	if(e==-1){
		for(i=1; i<=n; i++){
			if(nb[i]==SKUP_B) x[i]=b[i];
			else x[i]=0.0;
			//ukupniProfit += (x[i]*c[n+i]);
			//ukupniTroskovi += (a[n+5][i]*x[i]); //ukupna suma koju je zaradila - troskove koje je imala
		}
		//v -= ukupniTroskovi;
		printf("%.2lf\n", v);
		for(i=1; i<=n; i++)
			printf("%.2lf  ", x[i]);
		printf("\n");
	}
	
	return 0;
}
