#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

int n;
int m;

double **a;
double *x;
double *b;
double *c;

double budzet;
double *t;

int *BN;

double v;

void unesiPodatke()
{
    int i, j;

    n = 4;
    m = 4;

    a = (double **)malloc(sizeof(double *) * (m + n));
    for (i = 0; i < (m + n); i++)
    {
        a[i] = (double *)malloc(sizeof(double) * (m + n));
    }
    x = (double *)malloc(sizeof(double) * (m + n));
    b = (double *)malloc(sizeof(double) * (m + n));
    c = (double *)malloc(sizeof(double) * (m + n));
    t = (double *)malloc(sizeof(double) * (m + n));
    BN = (int *)malloc(sizeof(int) * (m + n));

    // x1 + x2 + x3 + x4
    scanf("%lf", &a[n][0]);
    scanf("%lf", &a[n][1]);
    scanf("%lf", &a[n][2]);
    scanf("%lf", &a[n][3]);

    // x1 + x2 + x4
    scanf("%lf", &a[n + 1][0]);
    scanf("%lf", &a[n + 1][1]);
    a[n + 1][2] = 0;
    scanf("%lf", &a[n + 1][3]);

    // x1 + x3 + x4
    scanf("%lf", &a[n + 2][0]);
    a[n + 2][1] = 0;
    scanf("%lf", &a[n + 2][2]);
    scanf("%lf", &a[n + 2][3]);

    // x2 + x3 + x4
    a[n + 3][0] = 0;
    scanf("%lf", &a[n + 3][1]);
    scanf("%lf", &a[n + 3][2]);
    scanf("%lf", &a[n + 3][3]);

    for (i = n; i < (m + n); i++)
    {
        scanf("%lf", &b[i]);
        BN[i] = SKUP_N;
        c[i] = 0;
    }

    for (i = 0; i < n; i++)
    {
        scanf("%lf", &c[i]);
        BN[i] = SKUP_B;
        b[i] = 0;
    }

    // ucitavanje budzeta
    scanf("%lf", &budzet);

    // ucitvanje troskova
    for (i = 0; i < n; i++)
    {
        scanf("%lf", &t[i]);
    }
}

int nadjiUlaz()
{
    int i, e;

    e = -1;

    for (i = 0; i < (m + n); i++)
    {
        if (BN[i] == SKUP_B && c[i] > 0) {
            e = i;
            break;
        }
    }
    return e;
}

int nadjiIzlaz(int e)
{
    int i, j;
    int l = -1;

    double min;

    for (i = 0; i < (m + n); i++)
    {
        if (BN[i] == SKUP_N && b[i] > 0) 
        {
            if (l == -1)
            {
                min = a[i][e] / b[i];
                l = i;
            }
            else if (a[i][e]/b[i] < min)
            {
                min = a[i][e]/b[i];
                l = i;
            }
        }
    }
    return l;
}

void pivot(int e, int l)
{
    int i, j;

    b[e] = 1 / b[l];
    for (j = 0; j < (m + n); j++)
    {
        if (BN[j] == SKUP_N && j != e) 
        {
            a[e][j] = b[j] / a[l][e];
        }
    }
    // a[e][l] = 

    for (i = 0; i < (m + n); i++)
    {
        if (BN[i] == SKUP_N && i != l)
        {
            for (j = 0; j < (m + n); j++)
            {
                if (BN[j] == SKUP_B && j != e)
                {
                    a[i][j] = a[i][j] - c[l];
                }
            }
            // a[l][e] = -a[e][l] / a[i][l]
        }
    }

    // v = v + a[l][e] * b[e];

    for (j = 0; j < (m + n); j++)
    {
        if (BN[j] == SKUP_B && j != e)
        {
            c[j] = -c[e] * b[e];
        }
    }

    BN[e] = SKUP_N;
    BN[l] = SKUP_B;
}

int main()
{
    int i, j, e, l;

    unesiPodatke();
    while ((e = nadjiUlaz()) != -1)
    {
        l = nadjiIzlaz(e);
        if (l == -1) 
        {
            printf("Problem neogranicen\n");
            break;
        }
        else 
        {
            pivot(e, l);
        }
    }

    for (i = 0; i < n; i++) 
    {
        if (BN[i] == SKUP_B)
        {
            x[i] = b[i];
        }
        else {
            x[i] = 0;
        }
    }

    printf("%lf\n", v);
    for (i = 0; i < n; i++)
    {
        printf("%lf ", x[i]);
    }

    printf("\n%d %d", e, l);
}