#include <stdio.h>
#include <stdlib.h>
#include <math.h>
typedef struct proces{
	int id;
	int vreme;
	int vaznost;
	double latencija;
}proces;

void rekonstrukcija(int **opt, int i, int j, proces *procesi){
	
	if(i>0 && j>0){
		if(opt[i][j] == opt[i-1][j]){
			i--;
			rekonstrukcija(opt, i, j, procesi);
		}
		else{
			printf("%3d", procesi[i].id);
			i--;
			rekonstrukcija(opt, i, j, procesi);
		}
	}
}

int main(){
	int n, p;
	int i, j;
	proces *procesi;
	int *niz;
	int dostupnoVreme;
	int ukupnoVreme;
	int ukupnaLatencija = 0;
	int brProcesa = 0;
	int **opt;
	scanf("%d", &n);
	
	niz = (int *)malloc(n*sizeof(int));
	
	for(i=0;i<n;i++)
		scanf("%d", &niz[i]);
		
	scanf("%d", &dostupnoVreme);
	scanf("%d", &p);
	
	procesi = (proces *)malloc((p+1)*sizeof(proces));
	
	for(i=1;i<=p;i++){
		scanf("%d%d%d%lf", &procesi[i].id,&procesi[i].vreme,&procesi[i].vaznost,&procesi[i].latencija);
	}
	
	
	ukupnoVreme = (dostupnoVreme*60)/n;
	for(i=1;i<=p;i++)
		ukupnaLatencija += procesi[i].latencija;
	
	ukupnoVreme += ceil(ukupnaLatencija);
	
	
	opt = (int**)malloc((p+1)*sizeof(int *));
	for(i=0;i<=p;i++)
		opt[i] = (int *)malloc((ukupnoVreme+1)*sizeof(int));

	
	
	
	
	for(i=0;i<=ukupnoVreme;i++)
		opt[0][i] = 0;
	
	
	for(i=0;i<=p;i++)
		opt[i][0] = 0;
	
	for(i=1;i<=p;i++){
		for(j=1;j<=ukupnoVreme;j++){
			if(procesi[i].vreme <= j){
				if(procesi[i].vaznost + opt[i][j-procesi[i].vreme] > opt[i-1][j]){
					opt[i][j] = procesi[i].vaznost + opt[i][j-procesi[i].vreme];
					brProcesa++;
				}
				else{
					opt[i][j] = opt[i-1][j];
				}
			}
			
		}
		
	}
	
	printf("%d\n%d", brProcesa,opt[p][ukupnoVreme]);
	
	//rekonstrukcija(opt, ukupnoVreme, ukupnoVreme, procesi);
	
}



