#include<stdio.h>
#include<stdlib.h>

int n,m;

double **a,*x;
int *b,*c;
int *BN;
double v = 0;

#define SKUP_N 0
#define SKUP_B 1

int nadjiUlaz()
{
	int j;
	int e = -1;
	
	for(j = 0;j < n+m;j++)
		if(BN[j] == SKUP_N && c[j] > 0)
		{
			e = j;
			break;
		}
	
	return e;
}

int nadjiIzlaz(int e)
{
	int i;
	int l = -1;
	double min;
	
	for(i = 0;i < n+m;i++)
		if(BN[i] == SKUP_B && a[i][e] > 0){
			if(l == -1)
			{
				min = b[i]/a[i][e]; 
				l = i;
			}else if(min > b[i]/a[i][e]){
				min = b[i]/a[i][e];
				l = i;
				
			}
		}
	return l;
}
void pivot(int e,int l)
{
	int i,j;
	
	b[e] = b[e]/a[l][e];
	
	for(j = 0;j < n+m;j++){
		if(BN[j] == SKUP_N && j != e){
			a[e][j] = a[l][j]/a[l][e];
		}
	}
	
	a[e][l] = 1/a[l][e];
	
	
	for(i = 0;i < n+m;i++){
		if(BN[i] == SKUP_B && i != l){
			b[i] = b[i] - a[i][e]*b[e]; 
			for(j = 0;j < n+m;j++){
				if(BN[j] == SKUP_N && j != e){
					a[i][j] = a[i][j] - b[e]*a[l][e]; 
				}
				
			}
			a[i][l] = -a[i][e] *a[e][l]; 
		}	
	}
	
	v = v + c[e]*b[e];
	
	for(j = 0;j < n+m;j++){
		if(BN[j] == SKUP_N && j != e){
			c[j] = c[j] - c[e] * a[e][j];
		}
	}
	c[l] = -c[e] * a[e][l];
	
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main()
{
	int e,l;
	v=0;
	int budzet = 0;
	int trosakDz1,trosakDz2,trosakDz3,trosakDz4;
	int cena1,cena2,cena3,cena4;
	// unos
	n = 4;
	m = 4;
	
	a = (double **)malloc((n+m)*sizeof(double *));
	
	for(int i = 0;i < (n+m);i++)
		a[i] = (double *)malloc((n+m)*sizeof(double));
	
	b = (int *)malloc((n+m)*sizeof(int));
	c = (int *)malloc((n+m)*sizeof(int));
	x = (double *)malloc((n+m)*sizeof(double));
	BN = (int *)malloc((n+m)*sizeof(int));
	
	
	
	// matrica a
	
	//1
	for(int j = 0;j<1;j++)
		for(int i = n;i<n+m;i++)
			scanf("%lf ",&a[i][j]);
	//2		
	scanf("%lf ",&a[n][1]);
	scanf("%lf ",&a[n+1][1]);
	a[n+2][1] = 0;
	scanf("%lf ",&a[n+3][1]);
	
	//3
	scanf("%lf ",&a[n][2]);
	a[n+1][2] = 0;
	scanf("%lf ",&a[n+2][2]);
	scanf("%lf ",&a[n+3][2]);
	
	//4
	a[n][3] = 0;
	scanf("%lf ",&a[n+1][3]);
	scanf("%lf ",&a[n+2][3]);
	scanf("%lf ",&a[n+3][3]);
	
	
	//cene
	scanf("%d ",&cena1);
	scanf("%d ",&cena2);
	scanf("%d ",&cena3);
	scanf("%d ",&cena4);
	
	
	//1
	a[n][0] *= (double)cena1;
	a[n+1][0] *= (double)cena1;
	a[n+2][0] *= (double)cena1;
	
	//2
	a[n][1] *= (double)cena2;
	a[n+1][1] *= (double)cena2;
	a[n+3][1] *= (double)cena2;
	
	//3
	a[n][2] *= (double)cena3;
	a[n+2][2] *= (double)cena3;
	a[n+3][2] *= (double)cena3;
	
	//4
	a[n][3] *= (double)cena4;
	a[n+1][3] *= (double)cena4;
	a[n+2][3] *= (double)cena4;
	a[n+3][3] *= (double)cena4;
	
	
	// unos vektora c
	for(int i = 0;i < n;i++)
	{
		scanf("%d ",&c[i]);
		BN[i] = SKUP_N;
	}
	
	for(int i = n;i < n+m;i++)
	{	
		c[n] = 0;
		BN[i] = SKUP_B;
	}
			
	// unos budzeta
	scanf("%d ",&budzet);
	
	b[0] = b[1] = b[2] = b[3] = 0;
	b[4] = b[5] = b[6] = b[7] = budzet;
 	
	
	scanf("%d ",&trosakDz1);
	scanf("%d ",&trosakDz2);
	scanf("%d ",&trosakDz3);
	scanf("%d ",&trosakDz4);
		
	// algoritam
	
	while((e=nadjiUlaz()) != -1)
	{
		l = nadjiIzlaz(e);
		if(l == -1){
			printf("Problem neogranicen\n");
			exit(0);
		}
		else{
			pivot(e,l);
		}
	}
	
	if(e == -1){
		for(int i = 0;i < n;i++){
			if(BN[i] == SKUP_B){
				x[i] = b[i];
			}else{
				x[i] = 0;
			}
			
		}
		printf("%4.2lf\n",v);
		
		for(int i = 0;i < n;i++)
			printf("%4.2lf ",x[i]);
		
	}
	
}






