#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

int m, n;

double **a;
double *b;
double *c;
double *x;
int *BN;

double *trosak;
double v;

void UnesiPodatke()
{
	int i, j;

	m = 5; //broj nejednacina
	n = 4; //broj nepoznatih

	a = (double **)malloc((n+m)*sizeof(double *));
	for(i=0; i<(n+m); i++)
		a[i] = (double *)malloc((n+m)*sizeof(double));

	b = (double *)malloc((n+m)*sizeof(double));
	c = (double *)malloc((n+m)*sizeof(double));
	x = (double *)malloc((n+m)*sizeof(double));
	trosak = (double *)malloc((n+m)*sizeof(double));
	BN = (int *)malloc((n+m)*sizeof(int));

	double dzem1sljiva, dzem1kajsija, dzem1visnja, dzem1secer;
	double dzem2sljiva, dzem2kajsija, dzem2secer;
	double dzem3sljiva, dzem3visnja, dzem3secer;
	double dzem4kajsija, dzem4visnja, dzem4secer;

	double secer;
	double sljiva;
	double kajsija;
	double visnja;

	double cena1dzem, cena2dzem, cena3dzem, cena4dzem;

	double budzet;

	double trosak1dzem, trosak2dzem, trosak3dzem, trosak4dzem;

	scanf("%lf%lf%lf%lf", &dzem1sljiva, &dzem1kajsija, &dzem1visnja, &dzem1secer);
	scanf("%lf%lf%lf", &dzem2sljiva, &dzem2kajsija, &dzem2secer);
	scanf("%lf%lf%lf", &dzem3sljiva, &dzem3visnja, &dzem3secer);
	scanf("%lf%lf%lf", &dzem4kajsija, &dzem4visnja, &dzem4secer);

	scanf("%lf", &secer);
	scanf("%lf", &sljiva);
	scanf("%lf", &kajsija);
	scanf("%lf", &visnja);

	scanf("%lf%lf%lf%lf", &cena1dzem, &cena2dzem, &cena3dzem, &cena4dzem);

	scanf("%lf", &budzet);

	scanf("%lf%lf%lf%lf", &trosak1dzem, &trosak2dzem, &trosak3dzem, &trosak4dzem);

	trosak[0] = trosak1dzem;
	trosak[1] = trosak2dzem;
	trosak[2] = trosak3dzem;
	trosak[3] = trosak4dzem;

	c[0] = cena1dzem;
	c[1] = cena2dzem;
	c[2] = cena3dzem;
	c[3] = cena4dzem;

	b[4] = secer;
	b[5] = sljiva;
	b[6] = kajsija;
	b[7] = visnja;
	b[8] = budzet;

	for(i=0; i<n; i++)
	{
		BN[i] = SKUP_N;
		b[i] = 0;
	}

	for(i=n; i<n+m; i++)
	{
		BN[i] = SKUP_B;
		c[i] = 0;
	}

	a[n][0] = dzem1secer;
	a[n][1] = dzem2secer;
	a[n][2] = dzem3secer;
	a[n][3] = dzem4secer;

	a[n+1][0] = dzem1sljiva;
	a[n+1][1] = dzem2sljiva;
	a[n+1][2] = dzem3sljiva;
	a[n+1][3] = 0;

	a[n+2][0] = dzem1kajsija;
	a[n+2][1] = dzem2kajsija;
	a[n+2][2] = 0;
	a[n+2][3] = dzem4kajsija;

	a[n+3][0] = dzem1visnja;
	a[n+3][1] = 0;
	a[n+3][2] = dzem3visnja;
	a[n+3][3] = dzem4visnja;

	a[n+4][0] = trosak1dzem;
	a[n+4][1] = trosak2dzem;
	a[n+4][2] = trosak3dzem;
	a[n+4][3] = trosak4dzem;

	v = 0;
}

int nadjiUlaz()
{
	int i;
	int e = -1;
	for(i=0; i<n+m; i++)
	{
		if(BN[i] == SKUP_N && c[i] > 0)
		{
			e = i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e)
{
	int l, i;
	double min;

	l = -1;

	for(i=0; i<n+m; i++)
	{
		if(BN[i] == SKUP_B && a[i][e] > 0)
		{
			if(l == -1)
			{
				min = b[i] / a[i][e];
				l = i;
			}
			else
			{
				if(b[i] / a[i][e] < min)
				{
					min = b[i] / a[i][e];
					l = i;
				}
			}
		}
	}

	return l;
}

void pivot(int e, int l)
{
	int i, j;
	b[e] = b[l] / a[l][e];
	for(j=0; j<n+m; j++)
	{
		if(BN[j] == SKUP_N && j != e)
		{
			a[e][j] = a[l][j] / a[l][e];
		}
	}
	a[e][l] = 1 / a[l][e];

	for(i=0; i<n+m; i++)
	{
		if(BN[i] == SKUP_B && i != l)
		{
			b[i] = b[i] - a[i][e] * b[e];
			for(j=0; j<n+m; j++)
			{
				if(BN[j] == SKUP_N && j != e)
				{
					a[i][j] = a[i][j] - a[i][e] * a[e][j];
				}
			}
			a[i][l] = -a[i][e] * a[e][l];
		}
	}

	v = v + c[e] * b[e];
	for(j=0; j<n+m; j++)
	{
		if(BN[j] == SKUP_N && j != e)
		{
			c[j] = c[j] - c[e] * a[e][j];
		}
	}
	c[l] = -c[e] * a[e][l];

	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main()
{
	int e, l;
	int i, j;

	UnesiPodatke();

	while((e = nadjiUlaz()) != -1)
	{
		l = nadjiIzlaz(e);
		if(l == -1)
		{
			printf("Problem neogranicen.\n");
			break;
		}
		else
		{
			pivot(e, l);
		}
	}

	if(e == -1)
	{
		for(j=0; j<n; j++)
		{
			if(BN[j] == SKUP_B)
			{
				x[j] = b[j];
			}
			else
			{
				x[j] = 0;
			}
		}

		double pom;
		for(j=0; j<n; j++)
		{
			pom = x[j] * trosak[j];
			v = v - pom;
		}

		printf("%.2lf\n", v);
		for(j=0; j<n; j++)
		{
			printf("%.2lf ", x[j]);
		}
	}
}