#include<stdio.h>
#include<stdlib.h>

#define skupB 1
#define skupN 0

double **a, *b, *c, *x;
double v;
int *bn;
int n, m;


void ucitajPodatke()
{
    int i;
    n = 4;
    m = 5;
    v = 0;

    a = (double **)malloc((n + m) * sizeof(double *));
    for(i = 0; i < (n + m); i++)
        a[i] = (double *)malloc((n + m) * sizeof(double));

    b = (double *)malloc((n + m) * sizeof(double));
    c = (double *)malloc((n + m) * sizeof(double));
    x = (double *)malloc((n + m) * sizeof(double));

    bn = (int *)malloc((n + m) * sizeof(int));

    double dzem1Sljiva, dzem1Kajsija, dzem1Visnja, dzem1Secer;
    double dzem2Sljiva, dzem2Kajsija, dzem2Secer;
    double dzem3Sljiva, dzem3Visnja, dzem3Secer;
    double dzem4Kajsija, dzem4Visnja, dzem4Secer;

    scanf("%lf", &dzem1Sljiva);
    scanf("%lf", &dzem1Kajsija);
    scanf("%lf", &dzem1Visnja);
    scanf("%lf", &dzem1Secer);

    scanf("%lf", &dzem2Sljiva);
    scanf("%lf", &dzem2Kajsija);
    scanf("%lf", &dzem2Secer);

    scanf("%lf", &dzem3Sljiva);
    scanf("%lf", &dzem3Visnja);
    scanf("%lf", &dzem3Secer);

    scanf("%lf", &dzem4Kajsija);
    scanf("%lf", &dzem4Visnja);
    scanf("%lf", &dzem4Secer);

    double secer, sljiva, kajsija, visnja;

    scanf("%lf", &secer);
    scanf("%lf", &sljiva);
    scanf("%lf", &kajsija);
    scanf("%lf", &visnja);

    double cena1, cena2, cena3, cena4;

    scanf("%lf", &cena1);
    scanf("%lf", &cena2);
    scanf("%lf", &cena3);
    scanf("%lf", &cena4);

    double budzet;
    double trosak1, trosak2, trosak3, trosak4;

    scanf("%lf", &budzet);

    scanf("%lf", &trosak1);
    scanf("%lf", &trosak2);
    scanf("%lf", &trosak3);
    scanf("%lf", &trosak4);

    c[0] = cena1 - trosak1;
    c[1] = cena2 - trosak2;
    c[2] = cena3 - trosak3;
    c[3] = cena4 - trosak4;
    c[4] = 0;
    c[5] = 0;
    c[6] = 0;
    c[7] = 0;
    c[8] = 0;

    b[0] = 0;
    b[1] = 0;
    b[2] = 0;
    b[3] = 0;
    b[4] = secer;
    b[5] = sljiva;
    b[6] = kajsija;
    b[7] = visnja;
    b[8] = budzet;
    
    bn[0] = skupN;
    bn[1] = skupN;
    bn[2] = skupN;
    bn[3] = skupN;
    bn[4] = skupB;
    bn[5] = skupB;
    bn[6] = skupB;
    bn[7] = skupB;
    bn[8] = skupB;

    //jos sade za matricu


    a[n][0] = dzem1Secer;
    a[n][1] = dzem2Secer;
    a[n][2] = dzem3Secer;
    a[n][3] = dzem4Secer;

    a[n + 1][0] = dzem1Sljiva;
    a[n + 1][1] = dzem2Sljiva;
    a[n + 1][2] = dzem3Sljiva;
    a[n + 1][3] = 0;

    a[n + 2][0] = dzem1Kajsija;
    a[n + 2][1] = dzem2Kajsija;
    a[n + 2][2] = 0;
    a[n + 2][3] = dzem4Kajsija;

    a[n + 3][0] = dzem1Visnja;
    a[n + 3][1] = 0;
    a[n + 3][2] = dzem3Visnja;
    a[n + 3][3] = dzem4Visnja;

    a[n + 4][0] = trosak1;
    a[n + 4][1] = trosak2;
    a[n + 4][2] = trosak3;
    a[n + 4][3] = trosak4;


}

int nadjiUlaz()
{
    int i, e = -1;

    for(i = 0; i < n + m; i++)
        if(bn[i] == skupN && c[i] > 0)
        {
            e = i;
            break;
        }

    return e;
}

int nadjiIzlaz(int e)
{
    int i, l = -1;
    double min;

    for(i = 0; i < n + m; i++)
    {
        if(bn[i] == skupB && a[i][e] > 0)
            if(l == -1)
            {
                l = i;
                min = b[i] / a[i][e];
            }
            else
            {
                if(b[i] / a[i][e] < min)
                {
                    l = i;
                    min = b[i] / a[i][e];
                }
            }
    }

    return l;
}


void pivot(int e, int l)
{
    int i, j;

    b[e] = b[l] / a[l][e];

    for(j = 0; j < n + m; j++)
        if(bn[j] == skupN && j != e)
            a[e][j] = a[l][j] / a[l][e];

    a[e][l] = 1 / a[l][e];

    for(i = 0; i < n + m; i++)
        if(bn[i] == skupB && i != l)
        {
            b[i] = b[i] - a[i][e] * b[e];

            for(j = 0; j < n + m; j++)
                if(bn[j] == skupN && j != e)
                    a[i][j] = a[i][j] - a[i][e] * a[e][j];

            a[i][l] = -a[i][e] * a[e][l];

        }

    v = v + c[e] * b[e];

    for(j = 0; j < n + m; j++)
        if(bn[j] == skupN && j != e)
            c[j] = c[j] - c[e] * a[e][j];
    
    c[l] = -c[e] * a[e][l];

    bn[e] = skupB;
    bn[l] = skupN;

}

void main()
{
    int i, e, l;

    ucitajPodatke();

    while((e = nadjiUlaz()) != -1)
    {
        l = nadjiIzlaz(e);

        if(l == -1)
        {
            printf("Problem je neogranicen\n");
            break;
        }
        else
            pivot(e, l);
    }

    if(e == -1)
    {
        for(i = 0; i < n; i++)
            if(bn[i] == skupB)
                x[i] = b[i];
            else
                x[i] = 0;

        printf("%.2lf\n", v);

        for(i = 0; i < n; i++)
            printf("%.2lf ", x[i]);
        printf("\n");
    }
}