#include <stdio.h>
#include <stdlib.h>
#define SKUP_B 1
#define SKUP_N 0

int n,m;
int *NB;
float **A,*c,*b,v,*x;
float budzet;

void unesiPodatke()
{
	int i;
	n=4;
	m=4;
	
	NB=(int*)malloc((n+m+1)*sizeof(int));
	A=(float**)malloc((n+m+1)*sizeof(float*));
	c=(float*)malloc((n+m+1)*sizeof(float));
	b=(float*)malloc((n+m+1)*sizeof(float));
	x=(float*)malloc((n+m+1)*sizeof(float));
	
	
	for(i=1;i<=m+n;i++)
	{
		A[i]=(float*)malloc((n+m+1)*sizeof(float));
	}
	
	float dzem1Sljiva,dzem1Kajsija,dzem1Visnja,dzem1Secer;
	float dzem2Sljiva,dzem2Kajsija,dzem2Secer;
	float dzem3Sljiva,dzem3Visnja,dzem3Secer;
	float dzem4Kajsija,dzem4Visnja,dzem4Secer;
	float secer,sljiva,kajsija,visnja;
	float cenaDzem1,cenaDzem2,cenaDzem3,cenaDzem4;
	float trosakDzem1,trosakDzem2,trosakDzem3,trosakDzem4;
	
	scanf("%f%f%f%f",&dzem1Sljiva,&dzem1Kajsija,&dzem1Visnja,&dzem1Secer);
	scanf("%f%f%f",&dzem2Sljiva,&dzem2Kajsija,&dzem2Secer);
	scanf("%f%f%f",&dzem3Sljiva,&dzem3Visnja,&dzem3Secer);
	scanf("%f%f%f",&dzem4Kajsija,&dzem4Visnja,&dzem4Secer);
	scanf("%f%f%f%f",&secer,&sljiva,&kajsija,&visnja);
	scanf("%f%f%f%f",&cenaDzem1,&cenaDzem2,&cenaDzem3,&cenaDzem4);
	scanf("%f",&budzet);
	scanf("%f%f%f%f",&trosakDzem1,&trosakDzem2,&trosakDzem3,&trosakDzem4);
	
	//printf("%.2f	%.2f	%.2f %.2f\n",trosakDzem1,trosakDzem2,trosakDzem3,trosakDzem4);
	
	A[n+1][1]=dzem1Secer; A[n+1][2]=dzem2Secer; A[n+1][3]=dzem3Secer; A[n+1][4]=dzem4Secer;
	A[n+2][1]=dzem1Sljiva; A[n+2][2]=dzem2Sljiva; A[n+2][3]=dzem3Sljiva; A[n+2][4]=0.0;
	A[n+3][1]=dzem1Kajsija; A[n+3][2]=dzem2Kajsija; A[n+3][3]=0.0; A[n+3][4]=dzem4Kajsija;
	A[n+4][1]=dzem1Visnja; A[n+4][2]=0.0; A[n+4][3]=dzem3Visnja; A[n+4][4]=dzem4Visnja;
	//A[n+5][1]=A[n+5][2]=A[n+5][3]=A[n+5][4]=1.0;
	
	b[n+1]=secer;
	b[n+2]=sljiva;
	b[n+3]=kajsija;
	b[n+4]=visnja;
	//b[n+5]=0;
	
	c[1]=cenaDzem1-trosakDzem1;
	c[2]=cenaDzem2-trosakDzem2;
	c[3]=cenaDzem3-trosakDzem3;
	c[4]=cenaDzem4-trosakDzem4;
	//c[5]=budzet;
	
	
	for(i=1;i<=n+m;i++)
	{
		if(i<=n)
		{
			b[i]=0;
			NB[i]=SKUP_N;
		}
		else
		{
			c[i]=0;
			NB[i]=SKUP_B;
		}
	}
	
	v=0.0;
}

void pivot(int e,int l)
{
	int i,j;
	b[e]=b[l]/A[l][e];
	A[e][l]=1/A[l][e];
	
	for(j=1;j<=n+m;j++)
	{
		if(NB[j]==SKUP_N && e!=j)
		{
			A[e][j]=A[l][j]/A[l][e];
		}
	}
	
	for(i=1;i<=n+m;i++)
	{
		if(NB[i] == SKUP_B && i!=l)
		{
			b[i]=b[i]-b[e]*A[i][e];
			
			for(j=1;j<=n+m;j++)
			{
				if(NB[j]==SKUP_N && e!=j)
				{
					A[i][j]=A[i][j]-A[i][e]*A[e][j];
				}
			}
			
			A[i][l]=-A[i][e]/A[l][e];//proveri
		}
	}
	
	for(j=1;j<=n+m;j++)
	{
		if(NB[j]==SKUP_N && e!=j)
		{
			c[j]=c[j]-c[e]*A[e][j];
		}
	}
	
	c[l]=-c[e]*A[e][l];
	v+=c[e]*b[e];
	NB[e]=SKUP_B;
	NB[l]=SKUP_N;
}

int nadjiUlaz()
{
	int i,e=-1;
	
	for(i=1;i<=n+m;i++)
	{
		if(NB[i]==SKUP_N && c[e]>0)
		{
			e=i;
			break;
		}
	}
	
	return e;
}

int nadjiIzlaz(int e)
{
	int i,l=-1;
	float min=-1;
	
	for(i=1;i<=n+m;i++)
	{
		if(NB[i]==SKUP_B && A[i][e] > 0)
		{
			if(min==-1 || min > b[i]/A[i][e])
			{
				min=b[i]/A[i][e];
				l=i;
			}
		}
	}
	
	return l;
}

int main()
{
	int i,e,l;
	
	unesiPodatke();
	
	while((e=nadjiUlaz())!=-1)
	{
		l=nadjiIzlaz(e);
		if(l==-1)
		{
			printf("Neogranicen problem\n");
			break;
		}
		else
		{
			pivot(e,l);
		}
	}
	
	if(e==-1)
	{
		printf("%.2f\n",v);
		for(i=1;i<=n;i++)
		{
			if(NB[i]==SKUP_B)
				x[i]=b[i];
			else x[i]=0;
			
			printf("%.2f	",x[i]);
		}
		printf("\n");
	}
}
