#include <stdio.h>
#include <stdlib.h>

#define skupb 1
#define skupn 0

double **a, *b, *c, *x;
int *bn;
double v, m, n;


void unosPodataka() {
	int i, j, m, n;
	
	n=4;
	m=5;
		
	double dzemSljiva1, dzemKajsija1, dzemVisnja1, dzemSecer1;
	double dzemSljiva2, dzemKajsija2, dzemSecer2;
	double dzemSljiva3, dzemVisnja3, dzemSecer3;
	double dzemKajsija4, dzemVisnja4, dzemSecer4;
	
	double secer, sljiva, kajsija, visnja;
	double cenaDzem1, cenaDzem2, cenaDzem3, cenaDzem4;
	
	double budzet;
	
	double trosakDzem1, trosakDzem2, trosakDzem3, trosakDzem4;

	a=(double**)malloc((m+n)*sizeof(double*));
	b=(double*)malloc((m+n)*sizeof(double));
	c=(double*)malloc((m+n)*sizeof(double));
	x=(double*)malloc((m+n)*sizeof(double));
	bn=(int*)malloc((m+n)*sizeof(int));
	
	for(i=0; i<n+m; i++) a[i]=(double*)malloc((n)*sizeof(double));
			
	scanf("%lf %lf %lf %lf", &dzemSljiva1, &dzemKajsija1, &dzemVisnja1, &dzemSecer1);
	scanf("%lf %lf %lf", &dzemSljiva2, &dzemKajsija2, &dzemSecer2);
	scanf("%lf %lf %lf", &dzemSljiva3, &dzemVisnja3, &dzemSecer3);
	scanf("%lf %lf %lf", &dzemKajsija4, &dzemVisnja4, &dzemSecer4);
	
	scanf("%lf", &secer);
	scanf("%lf", &sljiva);
	scanf("%lf", &kajsija);
	scanf("%lf", &visnja);

	
	scanf("%lf%lf%lf%lf", &cenaDzem1, &cenaDzem2, &cenaDzem3, &cenaDzem4);
	
	scanf("%lf", &budzet);
	
	scanf("%lf%lf%lf%lf", &trosakDzem1, &trosakDzem2, &trosakDzem3, &trosakDzem4);

	for(i=0; i<n; i++) {
		//scanf("%lf", &c[i]);
		bn[i]=skupb;
		b[i]=0;
	}
	
	for(i=n; i<n+m; i++) {
		//scanf("%lf", b[i]);
		bn[i]=skupn;
		c[i]=0;
	}

	b[n]=secer;			
	b[n+1]=sljiva;		b[n+2]=kajsija;
	b[n+3]=visnja;		b[n+4]=budzet;
	
	c[0]=cenaDzem1;		c[1]=cenaDzem2;
	c[2]=cenaDzem3;		c[3]=cenaDzem4;

	a[n][0]=trosakDzem1;	a[n][1]=trosakDzem2;
	a[n][2]=trosakDzem3;	a[n][3]=trosakDzem4;
	
	
	a[n+1][0]=dzemSljiva1;	a[n+1][1]=dzemKajsija1;
	a[n+1][2]=dzemVisnja1;	a[n+1][3]=dzemSecer1;
	
	
	a[n+2][0]=dzemSljiva2;	a[n+2][1]=dzemKajsija2;
	a[n+2][2]=0;			a[n+2][3]=dzemSecer2;
	
	
	a[n+3][0]=dzemSljiva3;	a[n+3][1]=0;
	a[n+3][2]=dzemVisnja3;	a[n+3][3]=dzemSecer3;
	
	
	a[n+4][0]=0;			a[n+4][1]=dzemKajsija4;
	a[n+4][2]=dzemVisnja4;	a[n+4][3]=dzemSecer4;


	printf("\n b[] \n");
	
	for(i=0; i<n+m; i++) {
			printf("%lf ", b[i]);
	}
	printf("\n c[] \n");
	
	for(i=0; i<n+m; i++) {
			printf("%lf ", c[i]);
	}
	printf("\n a[][] \n");
	
	for(i=0; i<n+m; i++) {
		for(j=0; j<n; j++) {
			printf("%lf ", a[i][j]);
		}
		printf("\n");
	}
	
	
	v=0.0;
}

int ulaz() {
	int e=-1, i;
	
	for(i=0; i<m+n; i++) {
		if(bn[i]==skupn && c[i]>0) {
			e=i;
			break;
		}
	}
	
	return e;
}

int izlaz(int e) {
	int i, l=-1;
	double min;
	
	for(i=0; i<m+n; i++) {
		if(bn[i]==skupb && a[i][e]>0) {
			if(l==-1) {
				min=b[i]/a[i][e];
				l=i;
			}
			else {
				if(b[i]/a[i][e] < min) {
					min= b[i]/a[i][e];
					l=i;
				}
			}
		}
	}
	
	return l;
}

void pivot(int e, int l) {
	int i, j;
	b[l]=b[e]/a[e][l]; //
	
	for(i=0; i<m+n; i++) {
		if(bn[i]==skupn && i!=e) {
			a[l][i]=a[e][i]/a[l][e]; //
		}
	}
	
	a[l][e]=1/a[e][l];
	
	for(i=0; i<m+n; i++) {
		if(bn[i]==skupb && i!=l) {
			b[i]=b[i]-b[e]*a[e][i];
			
			for(j=0; j<m+n; j++) {
				if(bn[j]==skupb && j!=e) {
					a[i][j]=a[i][j]-a[e][j]*a[e][i];
				}
			}
			
			a[l][i]=-a[l][e]/a[e][l]; //
		}
	}
	
	v+=c[e]+b[e];
	
	for(i=0; i<m+n; i++) {
		if(bn[i]==skupn && i!=e) {
			c[i]=c[i]-c[e]*a[e][l]; //
		}
	}
	
	c[l]=-c[e]/a[e][l]; //	
	
	bn[e]=skupb;
	bn[l]=skupn;
}

int main() {
	int i, e, l;
	
	unosPodataka();
	
	while((e=ulaz())!=-1) {
		l=izlaz(e);
		
		if(l==-1) {
			printf("Greska!\n");
			break;
		}
		else {
			pivot(e, l);
		}
	}
	
	if(e==-1) {
		
		printf("%lf\n", v);
		
		for(i=0; i<n; i++) {
			if(bn[i]==skupb) {
				x[i]=b[i];
			}
			else {
				x[i]=0;
			}
			
			printf("%lf ", x[i]);
		}
		
	}
	
	return 0;
}
